function GBH_OnLoad(self)
    self:RegisterEvent("VARIABLES_LOADED"); 	
    self:RegisterEvent("PLAYER_LOGIN");
    self:RegisterEvent("PLAYER_ENTERING_WORLD");	
    self:RegisterEvent("COMBAT_LOG_EVENT");
    self:RegisterEvent("CHAT_MSG_SYSTEM");
    self:RegisterEvent("CHAT_MSG_ADDON");
    self:RegisterEvent("WHO_LIST_UPDATE");
    RegisterAddonMessagePrefix("GBH_HL_SYNC_REQ")
    RegisterAddonMessagePrefix("GBL_IL_SYNC_REQ")
    RegisterAddonMessagePrefix("GBH_HL_UPDATE")
    RegisterAddonMessagePrefix("GBL_IL_UPDATE")
    RegisterAddonMessagePrefix("GBH_HL_CLEAR")
    RegisterAddonMessagePrefix("GBL_FORCE")
    RegisterAddonMessagePrefix("GBH_HL_SPLIT")   
    RegisterAddonMessagePrefix("GBH_SET_REP")
    RegisterAddonMessagePrefix("GBH_GF_SYNC_REQ")
    RegisterAddonMessagePrefix("GBH_GF_UPDATE_1")
    RegisterAddonMessagePrefix("GBH_GF_UPDATE_2")
    RegisterAddonMessagePrefix("GBH_GF_UPDATE_3")
    
    --local faction init
    GBH_OnInitialize()
    
    if GBH_FactionData == nil then
        GBH_FactionData = {}
        GBH_CreateNewProject(select(1, GetGuildInfo("player")))
        --GBH_FactionData[1].name = select(1, GetGuildInfo("player")) --in case of guild change
        GBH_AddFaction(GBL_GuildFactions[1].title , GBL_GuildFactions[1].description , false, "1",0)
        GBH_AddFaction(GBL_GuildFactions[2].title , GBL_GuildFactions[2].description , false, "2",0)
        GBH_AddFaction(GBL_GuildFactions[3].title , GBL_GuildFactions[3].description , false, "3",0)
        GBH_AddFaction(GBL_GuildFactions[4].title , GBL_GuildFactions[4].description , false, "4",0)
        GBH_AddFaction(GBL_GuildFactions[5].title , GBL_GuildFactions[5].description , false, "5", 0)    
    end     
end

function GBH_OnEvent(self, event, ...)
    local arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8,arg9 = ...;    
    if event == "VARIABLES_LOADED" then 
        GBH_HitListFrame:RegisterForDrag("LeftButton")    
        GBH_Init()        
        
        if not GBH_Config["WatchedFaction"] then    
            GBH_Config["WatchedFaction"] = 0
        end 
        
        --GBH_FactionData[1].name = select(1, GetGuildInfo("player")) --in case of guild change
        
    elseif (event == "PLAYER_LOGIN") then
       --GBH_Init()   
       --GBH_Purge()
       
    elseif (event == "PLAYER_ENTERING_WORLD") then
        --GBH_Init()
        
        GBH_ActionQueueInit()
        GBH_ActionQueueAdd([[GBH_FactionData[1].name = select(1, GetGuildInfo("player"))]], 10)
        GBH_ActionQueueAdd([[ChatThrottleLib:SendAddonMessage("ALERT","GBH_HL_SYNC_REQ","","GUILD")]], 10)
        GBH_ActionQueueAdd([[ChatThrottleLib:SendAddonMessage("ALERT","GBL_IL_SYNC_REQ","","GUILD")]], 10)
        GBH_ActionQueueAdd([[ChatThrottleLib:SendAddonMessage("ALERT","GBL_GF_SYNC_REQ","","GUILD")]], 10)
        --GBH_FactionData[1].name = select(1, GetGuildInfo("player")) --in case of guild change
        if GBH_Config["scale"] ~= nil then
            GBH_HitListFrame:SetScale(GBH_Config["scale"])
        end
        --GBH_Purge()
        GuildRoster()
       
    --check for duel victory
    elseif (event == "CHAT_MSG_SYSTEM") then
        local s,e,winner,loser,f,i,audit    
        s,e,winner,loser = string.find(arg1,"(.+) has defeated (.+) in a duel")     
        if winner == nil then return end    
      
        local f, i = IsBountyOpen(loser)      
        if (winner == UnitName("player")) and (f == true) then   
            local claimer = UnitName("player");
            local amount = GBH_HitList[i].amount      
            GBH_Msg("[GBH] Bounty claimed on "..loser.." {cross} "..GBL_CopperToGold(amount).." {circle}");         
            GBL_AddLargess(amount);
            GBH_AddLocalBountyRep(amount)
            GBH_HitList[i].state = "GBH_CLAIMED"
            GBH_HitList[i].claimer = winner; 
            if GBH_HitList[i].audit == nil then
                audit = 0
            else
                audit = GBH_HitList[i].audit
            end
            local id  = GBH_HitList[i].id
            local timestamp = time()
            local name = GBH_HitList[i].name
            local issuer = GBH_HitList[i].issuer         
            local msg = id..","..timestamp..","..name..","..issuer..","..amount..","..winner..","..GBH_HitList[i].state..","..audit;       
            GBH_HitListUpdate()
            ChatThrottleLib:SendAddonMessage("NORMAL","GBH_HL_UPDATE", msg, "GUILD");         
        end  
   
   --check for killing blow      
    elseif (event == "COMBAT_LOG_EVENT") and (arg9 ~= UnitName("player")) and arg9 ~= nil then  
        --print(event)
        local n1,n2,destName,destRealm = string.find(arg9,"(.+)-(.+)")
        if destName == nil then
           destName = arg9
           destRealm = GetRealmName()
        end     
      
        if not (arg2 == "PARTY_KILL" or (arg2 == "UNIT_DIED" and (arg5 == UnitName("player") or GBH_IsBountyLocked(destName) and CanEditOfficerNote()))) then
            return
        end        
 
        local audit
        local f, i = IsBountyOpen(destName)  
        
        --GBL_LargessMessage(arg2..": "..destName..":"..i..":"..GBH_HitList[i].state..":"..GBH_HitList[i].class)       
                  
        if (i>0) and (GBH_HitList[i].state == "GBH_OPEN" or GBH_HitList[i].state == "GBH_OPEN_S" or GBH_HitList[i].state == "GBH_OPEN_SL" or GBH_HitList[i].state == "GBH_OPEN_L") then 
            --officer lock
            if GBH_IsBountyLocked(destName) and not CanEditOfficerNote() then
                return
            end
            if GBH_HitList[i].class == nil then 
                print(GBH_UnitType(arg8))
                if GBH_UnitType(arg8) == 4 then
                    --just killed pet
                    if GBH_HitList[i].class ~= destName then
                        return
                    end
                end
            end 
        
            local claimer = UnitName("player");
            local amount = GBH_HitList[i].amount;      
            local j
            local id  = GBH_HitList[i].id
            local timestamp = time()
            local name = GBH_HitList[i].name
            local issuer = GBH_HitList[i].issuer      
            local rname           
       
            --split with raid or party
            if GBH_HitList[i].state == "GBH_OPEN_S" then
                --raid
                local n = GetNumRaidMembers()    
                local nr = GBH_NumGuildMatesInGroup()
                amount = floor(amount/(nr+1))            
                for j = 1, n do                    
                    rname, _, _, _, _, _, _, online, _, _, _ = GetRaidRosterInfo(j)
                    if UnitIsInMyGuild(rname) and rname ~= UnitName("player") then
                    --if UnitIsInMyGuild(rname) then
                        timestamp = time()
                        table.insert(GBH_HitList,{id=id,name=name,amount=amount,issuer=issuer,timestamp=timestamp,state="GBH_CLAIMED",claimer=rname,audit=1,faction=GBH_HitList[i].faction,realm=GBH_HitList[i].realm,zone=GBH_HitList[i].zone,xcoord=GBH_HitList[i].xcoord,ycoord=GBH_HitList[i].ycoord,intelage=intelage,class=GBH_HitList[i].class,race=GBH_HitList[i].race,level=GBH_HitList[i].level});   
                        local msg =  id..j..","..timestamp..","..name..","..issuer..","..amount..","..rname..",".."GBH_CLAIMED"..","..1;       
                        GBH_Msg("[GBH] Bounty claimed on "..destName.." {cross} "..GBL_CopperToGold(amount).." {circle}");                          
                        GBH_HitListUpdate()
                        ChatThrottleLib:SendAddonMessage("ALERT","GBH_HL_UPDATE", msg, "GUILD"); 
                        if rname ~= UnitName("player") then
                            ChatThrottleLib:SendAddonMessage("ALERT","GBH_HL_SPLIT", name..","..amount, "WHISPER", rname)
                        end
                    end
                end   

                --party
                if n == 0 then 
                    n = GetNumPartyMembers()
                    --create new claimed bounties for party
                    local arg
                    for j = 1, n do
                        if GetPartyMember(j) then                                                    
                            rname = UnitName("party"..j)
                            if UnitIsInMyGuild(rname) and rname ~= UnitName("player") then
                            --if UnitIsInMyGuild(rname) then
                                timestamp = time()
                                table.insert(GBH_HitList,{id=id,name=name,amount=amount,issuer=issuer,timestamp=timestamp,state="GBH_CLAIMED",claimer=rname,audit=1,faction=GBH_HitList[i].faction,realm=GBH_HitList[i].realm,zone=GBH_HitList[i].zone,xcoord=GBH_HitList[i].xcoord,ycoord=GBH_HitList[i].ycoord,intelage=intelage,class=GBH_HitList[i].class,race=GBH_HitList[i].race,level=GBH_HitList[i].level});   
                                local msg =  id..j..","..timestamp..","..name..","..issuer..","..amount..","..rname..",".."GBH_CLAIMED"..","..1;       
                                GBH_Msg("[GBH] Bounty claimed on "..destName.." {cross} "..GBL_CopperToGold(amount).." {circle}");                                  
                                GBH_HitListUpdate()
                                arg = name..","..amount
                                ChatThrottleLib:SendAddonMessage("ALERT","GBH_HL_UPDATE", msg, "GUILD"); 
                                if rname ~= UnitName("player") then
                                    ChatThrottleLib:SendAddonMessage("ALERT","GBH_HL_SPLIT", arg, "WHISPER", rname)
                                end
                            end
                        end
                    end                   
                end
            end
        
            --normal behavior (no split)
            GBH_Msg("[GBH] Bounty claimed on "..destName.." {cross} "..GBL_CopperToGold(amount).." {circle}");         
            GBL_AddLargess(amount);
            if issuer ~= claimer then
                GBH_AddLocalBountyRep(amount)
            end
            GBH_HitList[i].state = "GBH_CLAIMED"
            GBH_HitList[i].claimer = claimer; 
            GBH_HitList[i].amount = amount
            local id  = GBH_HitList[i].id
            local timestamp = time()
            local name = GBH_HitList[i].name
            local issuer = GBH_HitList[i].issuer              
            if GBH_HitList[i].audit == nil then
               audit = 0
            else
                audit = GBH_HitList[i].audit
            end
            local msg = id..","..time()..","..name..","..issuer..","..amount..","..claimer..","..GBH_HitList[i].state..","..audit;       
            GBH_HitListUpdate()
            ChatThrottleLib:SendAddonMessage("ALERT","GBH_HL_UPDATE", msg, "GUILD");        
        end 
    
    --sync
    elseif (event == "CHAT_MSG_ADDON") then       
        --bounty list
        if (arg1 == "GBH_HL_SYNC_REQ") then           
            if arg4 ~= UnitName("player") then
                gbh_debug("GBH_HL_SYNC_REQ")
                GBH_HL_DoSync(arg4);          
            end
            
        elseif (arg1 == "GBH_HL_UPDATE") then            
            if arg4 ~= UnitName("player") then                
                gbh_debug("GBH_HL_UPDATE")
                GBH_HL_DoUpdate(arg2,arg4);
            end
            
        elseif(arg1 == "GBH_HL_CLEAR") then
            gbh_debug("GBH_HL_CLEAR")
            GBH_HitList = {}
            GBH_HitListUpdate() 
            
        elseif(arg1 == "GBL_FORCE") then
            gbh_debug("GBH_FORCE")
            GBL_Largess = tonumber(arg2)
            MoneyFrame_Update(GBH_LargessAmountFrame, GBL_Largess); 
        
        --item largess list
        elseif (arg1 == "GBL_IL_SYNC_REQ") then             
            if arg4 ~= UnitName("player") then
                gbh_debug("GBL_IL_SYNC_REQ")
                GBL_IL_DoSync(arg4);   
            end
            
        elseif (arg1 == "GBL_IL_UPDATE") then                  
            if arg4 ~= UnitName("player") then
                gbh_debug("GBL_IL_UPDATE")
                GBL_IL_DoUpdate(arg2);                
            end
            
        elseif (arg1 == "GBH_HL_SPLIT") then
            gbh_debug("GBH_HL_SPLIT")
            local name, amount = string.split(",",arg2)
            GBH_Msg("[GBH] Bounty claimed on "..name.." {cross} "..GBL_CopperToGold(amount).." {circle}");
            GBL_AddLargess(amount)
            if issuer ~= claimer then
                GBH_AddLocalBountyRep(amount)
            end
        
        --guild factions
        elseif (arg1 == "GBH_GF_SYNC_REQ") then
            --if arg4 ~= UnitName("player") then
                gbh_debug("GBH_GF_SYNC_REQ")
                GBH_GF_DoSync()
            --end
        
        elseif (arg1 == "GBH_GF_UPDATE_1") then            
            --if arg4 ~= UnitName("player") then
                gbh_debug("GBH_GF_UPDATE_1")
                GBH_GF_DoUpdateTitle(arg2);
            --end
        
        elseif (arg1 == "GBH_GF_UPDATE_2") then            
            --if arg4 ~= UnitName("player") then
                gbh_debug("GBH_GF_UPDATE_2")
                GBH_GF_DoUpdateDescription(arg2);
            --end
            
        elseif (arg1 == "GBH_GF_UPDATE_3") then            
            --if arg4 ~= UnitName("player") then
                gbh_debug("GBH_GF_UPDATE_3")
                GBH_GF_DoUpdateDiscounts(arg2);
            --end
            
        elseif (arg1 == "GBH_SET_REP") then
            gbh_debug("GBH_SET_LOCAL_REP")
            local rep1, rep2, rep3, rep4, rep5 = string.split(",", arg2)
            GBH_SetReputation(2, tonumber(rep1)-42000)
            GBH_SetReputation(3, tonumber(rep2)-42000)
            GBH_SetReputation(4, tonumber(rep3)-42000)
            GBH_SetReputation(5, tonumber(rep4)-42000)
            GBH_SetReputation(6, tonumber(rep5)-42000)
            
        end
    
    --intel
    elseif event == "WHO_LIST_UPDATE" then        
        local i,j
        local n = GetNumWhoResults()      
        local pname,prealm = UnitName("player")
        local name, guild, level, race, class, zone
        if GBH_BountySpyCounter ~= nil then
            GBH_BountySpyCounter = GBH_BountySpyCounter + 1        
            if n == 0 then
                GBL_LargessMessage(GBH_BountySpyNames[GBH_BountySpyCounter].name.." could not be found.")
            end
            for i = 1,n do
                name,guild,level,race,class,zone = GetWhoInfo(i)         
                GBL_LargessMessage("Found: "..name.." <"..guild.."> "..tostring(level).." "..race.." "..class.." "..zone)
                for j = 1, #GBH_IntelList do
                    if GBH_IntelList[j].name == name then
                        GBH_IntelList[j].level = tostring(level)
                        GBH_IntelList[j].race = race
                        GBH_IntelList[j].class = class
                        GBH_IntelList[j].zone = zone
                        GBH_IntelList[j].realm = prealm
                        GBH_IntelList[j].intelage = time()
                    end
                end
            end
            if GBH_BountySpyCounter >= GBH_BountySpyCnt then
                GBL_LargessMessage("All guild agents have reported in.")
                FriendsFrame:RegisterEvent("WHO_LIST_UPDATE")
            end  
        end
    end  
end      
  