function GBH_Commands(args)  
   local s,e,cmd,arg1,arg2,arg3,arg4 = string.find(args,"(%a*)%s?([.?%a%d]*)%s?([.?%a%d]*)%s?([.?%a%d-?]*)%s?([.?%a%d-?]*)")    
   
   --debug
   if cmd == "debug" then
      if arg1 == "on" then
         GBH_Config["debug"] = true
         GBL_LargessMessage("GBH: debug on")
      elseif arg1 == "off" then
         GBH_Config["debug"] = false
         GBL_LargessMessage("GBH: debug off")
      end    

    --show the GUI
    elseif cmd == "show" then
        GBH_ToggleHitList()
        
   --set default channel
   elseif cmd == "channel" then 
      if arg1 == "guild" then
         GBH_Config["channel"] = "GUILD"
      elseif arg1 == "party" then
         GBH_Config["channel"] = "PARTY"
      elseif arg1 == "officer" then
         GBH_Config["channel"] = "OFFICER"
      elseif arg1 == "private" then
         GBH_Config["channel"] = "PRIVATE"
      end
      
   --list hit list
   elseif cmd == "list" then
      GBH_DisplayList() 
      
   --set guild bank largess cut
   elseif cmd == "cut" then
      GBL_SetGBCut(arg1)
   --place a bounty
   
   elseif cmd == "bounty" then
      if arg1 == nil then
         GBH_BuyBounty() 
      elseif arg1 == "bg" then
         GBH_AddBGBounties(tonumber(arg2))
      else    
         GBH_AddBounty(UnitName("target"),arg1)
      end
      
   --resync hit list
   elseif cmd == "sync" then
      ChatThrottleLib:SendAddonMessage("ALERT","GBH_HL_SYNC_REQ", "", "GUILD");   
      ChatThrottleLib:SendAddonMessage("ALERT","GBL_IL_SYNC_REQ", "", "GUILD");
      
   --clear hit list
   elseif cmd == "clear" then
      if arg1 == "all" then  
         if GBH_GetAdminLevel() >= 2 then
            ChatThrottleLib:SendAddonMessage("ALERT","GBH_HL_CLEAR", "", "GUILD");
         else
            GBL_LargessMessage("You don't have permission to clear the list.")
         end 
      elseif arg1 == "" then
         GBH_HitList = {}
      end   
      
   --largess commands
   elseif cmd == "largess" then
      if arg1 == "" then
         GBL_LargessMessage("Your current guild Largess is "..GBL_CopperToGold(GBL_Largess))
      elseif arg1 == "report" then
         GBL_GuildLargessReport()
      elseif arg1 == "set" then
         GBL_SetLargess(arg2,arg3)
      elseif arg1 == "mod" then
         GBL_ModLargess(arg2,arg3)
      end   
      
   --audit commands
   elseif cmd == "audit" then
      if arg1 == "reset" then
         --GBH_AuditData = nil
      elseif arg1 == "print" then
         --GBH_AuditPrint()
      elseif arg1 == "" then 
         GBL_AuditPrep()         
      --GBH_DoAudit()
      elseif arg1 == "init" then
         --GBH_AuditInit()
      elseif arg1 == "load" then
         --GBH_AuditLoad()
      elseif arg1 == "save" then
         --GBH_AuditSave()
      elseif arg1 == "bounties" then
         GBL_AuditInit()
         GBL_AuditLoad()
         GBH_AuditBounties()
         GBL_AuditSave()
      end      
   
   --intel commands
   elseif cmd == "intel" then
      if arg1 == "post" then
         GBH_IntelPost()
      elseif arg1 == "spy" then
         GBH_IntelSpy()
      elseif arg1 == "report" then
         GBH_IntelReport()     
      end   
   
   --version
   elseif cmd == "version" then
      GBL_LargessMessage("Guild Bounty Hunter v"..GBH_VERSION);
     
    --set UI scale
    elseif cmd == "scale" then
        if arg1 ~= nil then
            GBH_Config["scale"] = arg1
            GBH_HitListFrame:SetScale(arg1)
        end
        
    --guild bank item import
    elseif cmd == "gbimport" then
        GBH_ImportGuildBankItems(arg1)
                 
    --set the minimum officer rank
    elseif cmd == "setminrank" then
        GBL_SetMinOfficerRank(arg1)
        
    --set reputations for guild groups
    elseif cmd == "setrep" then
        if arg1 == nil or arg2 == nil or arg3 == nil then
            GBH_Help(cmd)
        else
            gbh_debug("setrep: "..arg1.." "..arg2.." "..arg3.." "..arg4)
            GBH_SetGuildRep(arg1, tonumber(arg2), arg3, tonumber(arg4))
        end            
    
   --help
   elseif cmd == "help" then
      GBH_Help(arg1)    
   else 
      GBH_Help()
   end
end

function GBH_GetAdminLevel()
   if CanEditOfficerNote() and CanEditGuildInfo() then
      return GBH_SUPER_ADMIN
   elseif CanEditOfficerNote() then
      return GBH_ADMIN
   else
      return GBH_USER
   end   
end

function GBH_BuyBounty()
   --local dialog = StaticPopup_Show("ADD_BOUNTY") 
   GBH_AddBountyFrame:Show()
   --[[
   if (dialog) then
      dialog.data  = varName     
      dialog.data2 = varName2
   end  
   local text = _G[dialog:GetName().."Text"];
   local editBox = _G[dialog:GetName().."EditBox"];
   local button1 = _G[dialog:GetName().."Button1"];  
   local moneyInputFrame = _G[dialog:GetName().."MoneyInputFrame"];
   dialog:SetHeight(16 + text:GetHeight() + 8 + editBox:GetHeight() + 8 + button1:GetHeight() + 8 + moneyInputFrame:GetHeight() + 8);   
   ]]--
end

function GBH_Purge()
   local i,n
   i = 1
   if GBH_HitList == nil then
      return
   end
   n = #GBH_HitList
   while (i <= n) do      
      if GBH_HitList[i].audit == 2 and (((GBH_HitList[i].state == "GBH_CLAIMED") and (time() - GBH_HitList[i].timestamp) > GBH_PURGE_AGE_CLAIMED)) or
         (GBH_HitList[i].state == "GBH_DEL" and (time() - GBH_HitList[i].timestamp) > GBH_PURGE_AGE_DEL) then
         table.remove(GBH_HitList,i)
         n = n - 1
         i = i - 1
      end
      i = i + 1
   end
   GBH_HitListUpdate()
end
