--  ================================ new hooked functions  ================================
function GBH_GetNumFactions() 
   
   
   local OrigNumFactions = GBH_Orig_GetNumFactions();
   local GBHNumFactions = 0;
   if (GBH_FactionData[1] == nil) then 
      
      return OrigNumFactions;
   else
      GBHNumFactions = table.getn(GBH_FactionData);    
      
   end;
   
   
   local name, description, standingID, barMin, barMax, barValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, isWatched = GBH_GetFactionInfo(OrigNumFactions+1);
   
   if (isHeader and (isCollapsed)) then
      
      return OrigNumFactions + 1;
      
   else
      --GBH_Message(GBHNumFactions);    
      return OrigNumFactions + GBHNumFactions;
   end
end

function GBH_GetFactionInfo(factionIndex) 
   local OrigNumFactions = GBH_Orig_GetNumFactions();
   local GBHNumFactions = 0;
   if (GBH_FactionData[1] == nil) then 
      GBHNumFactions = 0;
   else
      GBHNumFactions = table.getn(GBH_FactionData);    
   end;
   
   local name, description, standingID, barMin, barMax, barValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild = GBH_Orig_GetFactionInfo(factionIndex);
   
   if (factionIndex > OrigNumFactions and factionIndex <= OrigNumFactions + GBHNumFactions) then
      
      local data = GBH_FactionData[factionIndex - OrigNumFactions];
      name = data.name;
      description = data.description;
      standingID = data.standingID;
      barMin = GBH_BarMinValues[standingID].minValue;
      barMax = GBH_BarMinValues[standingID].maxValue;
      barValue = data.value;
      atWarWith = data.atWarWith;
      canToggleAtWar = data.canToggleAtWar;
      isHeader = data.isHeader;
      isCollapsed = data.isCollapsed;
      isWatched = data.isWatched;
      
   end
   
   
   
   return name, description, standingID, barMin, barMax, barValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild;
end

function GBH_GetSelectedFaction() 
   --local ID = GBH_Orig_GetSelectedFaction();
   
   return GBH_SelectedFaction;
end

function GBH_SetSelectedFaction(ID) 
   GBH_SelectedFaction = ID;
   --GBH_Orig_SetSelectedFaction(ID);
   
end

function GBH_GetWatchedFactionInfo() 
   --GBH_Message("Get Watched faction info");
   --if InCombatLockdown() then return nil end;
   
   if GBH_Config == nil or GBH_Config["WatchedFaction"] == nil or GBH_Config["WatchedFaction"] == 0 then return nil,"",0,0,0; end;
   local name, description, standingID, barMin, barMax, barValue = GBH_GetFactionInfo(GBH_Config["WatchedFaction"]);
   
   return name, standingID, barMin, barMax, barValue;
end

function GBH_SetWatchedFactionIndex(index) 
   --GBH_Orig_SetWatchedFactionIndex(index);
   --GBH_WatchedFaction = index;
   
   GBH_Config["WatchedFaction"] = index
end

function GBH_IsFactionInactive(index)
   
   local OrigNumFactions = GBH_Orig_GetNumFactions();
   if ( (index>OrigNumFactions) and GBH_SelectedFaction == index) then
      ReputationDetailInactiveCheckBoxText:SetText(L_GBH_OWNFACTION);
      -- localization
      REPUTATION_MOVE_TO_INACTIVE = L_GBH_TEXT_JOIN_FACT;
      
      if GBH_FactionData[index-OrigNumFactions].leader == nil then
         -- localization
         --GBH_FactionDecTextLabel1:SetText(L_GBH_NO_FACTIONLEADER);
      elseif GBH_FactionData[index-OrigNumFactions].leader == ""then
         -- localization
         --GBH_FactionDecTextLabel1:SetText(L_GBH_NO_FACTIONLEADER);
      else
         -- localization
         --GBH_FactionDecTextLabel1:SetText(L_GBH_FACTION_LEADER..": "..GBH_FactionData[index-OrigNumFactions].leader);
      end
      --GBH_FactionDecText:Show();
      
      if GBH_FactionData[index-OrigNumFactions].standingID < 4 then
         ReputationDetailInactiveCheckBox:Disable();
         ReputationDetailInactiveCheckBoxText:SetTextColor(GRAY_FONT_COLOR.r, GRAY_FONT_COLOR.g, GRAY_FONT_COLOR.b);
      else
         
         ReputationDetailInactiveCheckBoxText:SetTextColor(NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b);
         ReputationDetailInactiveCheckBox:Enable();
         return GBH_FactionData[index-OrigNumFactions].ownFaction;
      end
      
      
   else
      --GBH_FactionDecText:Hide();
      
      REPUTATION_MOVE_TO_INACTIVE = ORIG_REPUTATION_MOVE_TO_INACTIVE;
      ReputationDetailInactiveCheckBox:Enable();
      ReputationDetailInactiveCheckBoxText:SetText(L_GBH_M_T_INACTIVE);
      ReputationDetailInactiveCheckBoxText:SetTextColor(NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b);
      return GBH_Orig_IsFactionInactive(index);
   end
   
   
   
end

function GBH_SetFactionInactive(index)
   local OrigNumFactions = GBH_Orig_GetNumFactions();
   if ( (index>OrigNumFactions) and GBH_SelectedFaction == index) then
      GBH_SetOwnFaction(index-OrigNumFactions);
   else
      GBH_Orig_SetFactionInactive(index);
   end
end

function GBH_SetFactionActive(index)
   local OrigNumFactions = GBH_Orig_GetNumFactions();
   if ( (index>OrigNumFactions) and GBH_SelectedFaction == index) then
      GBH_SetOwnFaction(0);
   else
      GBH_Orig_SetFactionActive(index);
   end
end

function GBH_CollapseFactionHeader(i)  
   local factionOffset = FauxScrollFrame_GetOffset(ReputationListScrollFrame);
   --local factionHeader = getglobal("ReputationHeader"..i-factionOffset);
   local factionHeader = getglobal("ReputationBar"..i-factionOffset.."FactionName");   
   
   if (GBH_FactionData[1] == nil ) then
      GBH_Orig_CollapseFactionHeader(i);    
   elseif factionHeader:GetText() == GBH_FactionData[1].name then      
      GBH_CollapseHeader(1);
      ReputationFrame_Update();
   else
      GBH_Orig_CollapseFactionHeader(i);
   end   
end

function GBH_CollapseHeader(collapse)
	GBH_FactionData[1].isCollapsed = collapse;
end

function GBH_ExpandFactionHeader(i)   
   local factionOffset = FauxScrollFrame_GetOffset(ReputationListScrollFrame);
   --local factionHeader = getglobal("ReputationHeader"..i-factionOffset);
   local factionHeader = getglobal("ReputationBar"..i-factionOffset.."FactionName");
   if not(GBH_FactionData[1] == nil) and factionHeader:GetText() == GBH_FactionData[1].name then
      GBH_CollapseHeader(nil);
      ReputationFrame_Update();      
   else
      GBH_Orig_ExpandFactionHeader(i);
   end   
end

function GBH_FactionToggleAtWar(index)
   
   local name = GBH_GetFactionInfo(index);
   
   local OrigNumFactions = GBH_Orig_GetNumFactions();
   local GBHNumFactions = 0;
   if not(GBH_FactionData[1] == nil) then
      GBHNumFactions = table.getn(GBH_FactionData);
   end
   
   if (index > OrigNumFactions and index <= OrigNumFactions + GBHNumFactions) then
      GBH_ToggleWar(index - OrigNumFactions);
      ReputationFrame_Update();
   else    
      GBH_Orig_FactionToggleAtWar(index);
   end
end

function GBH_ReputationBar_OnClick(self)
   --GBH_ModerateFrame:Hide();
   --GBH_OptionsFrame:Hide();
   GBH_Orig_ReputationBar_OnClick(self);
end

function GBH_AddFaction(name,description,canToggleAtWar,ID,initVal)
   local GBHNumFactions = table.getn(GBH_FactionData);
   -- debug localization
   --GBH_DebugMsg("Adding "..name..". Dec: "..description);
   
   local val = 0;
   local stID = 4;
   
   if not(initVal==nil) then
      local a,b,c,StandingID = GBH_GetStandingName(initVal)
      val = initVal;
      stID = StandingID;
   end
   
   table.insert(GBH_FactionData,{
         name = name, 
         description = description, 
         standingID = stID, 
         value = val, 
         initval = initVal,
         atWarWith = false, 
         canToggleAtWar = canToggleAtWar, 
         isHeader = false, 
         isCollapsed = false, 
         isWatched = false,
         ownFaction = false,
         ID = ID,
      }
   );
   
   --GBH_FactionData[1].version = version;
   
   ReputationFrame_Update();
   ReputationWatchBar_Update();
end

----- Manual setup functions
function GBH_CreateNewProject(name)
   if not(GBH_FactionData[1] == nil) then
      --GBH_Message(L_GBH_ARIP);
   else
      --GBH_Message(L_GBH_CNP..": "..name);
      currentTime = time();
      Pname = UnitName("PLAYER");
      
      GBH_FactionData = {
         [1] = {
            name = name, 
            description = "", 
            standingID = 4, 
            value = 0, 
            leader = Pname,
            atWarWith = false, 
            canToggleAtWar = false, 
            isHeader = true, 
            isCollapsed = nil, 
            isWatched = false,
            ownFaction = false,
            version = currentTime;
            created = currentTime;
         },
      };    
      GBH_OwnRank = 1;
      --GBH_UpdateRankText();
      --GBH_UpdateOptionsText();
      --GBH_ModerateFrame_OnLoad(GBH_ModerateFrame);
   end
end

function GBH_OnInitialize()
   
   
   GBH_Orig_GetNumFactions = GetNumFactions; 
   GetNumFactions = GBH_GetNumFactions;
   
   GBH_Orig_GetFactionInfo = GetFactionInfo; 
   GetFactionInfo = GBH_GetFactionInfo;
   
   GBH_Orig_GetSelectedFaction = GetSelectedFaction;
   GetSelectedFaction = GBH_GetSelectedFaction; 
   
   GBH_Orig_SetSelectedFaction = SetSelectedFaction;  
   SetSelectedFaction = GBH_SetSelectedFaction;
   
   GBH_Orig_SetWatchedFactionIndex = SetWatchedFactionIndex; 
   SetWatchedFactionIndex = GBH_SetWatchedFactionIndex;
   
   GBH_Orig_GetWatchedFactionInfo = GetWatchedFactionInfo;  
   GetWatchedFactionInfo = GBH_GetWatchedFactionInfo;   --x
   
   GBH_Orig_IsFactionInactive = IsFactionInactive;
   IsFactionInactive = GBH_IsFactionInactive;
   
   GBH_Orig_SetFactionInactive = SetFactionInactive;
   SetFactionInactive = GBH_SetFactionInactive;
   
   GBH_Orig_SetFactionActive = SetFactionActive;
   SetFactionActive = GBH_SetFactionActive;
   
   GBH_Orig_CollapseFactionHeader = CollapseFactionHeader;
   CollapseFactionHeader = GBH_CollapseFactionHeader;
   
   GBH_Orig_ExpandFactionHeader = ExpandFactionHeader;
   ExpandFactionHeader = GBH_ExpandFactionHeader;
   
   GBH_Orig_FactionToggleAtWar = FactionToggleAtWar;
   FactionToggleAtWar = GBH_FactionToggleAtWar;
   
   GBH_Orig_ReputationBar_OnClick = ReputationBar_OnClick;
   ReputationBar_OnClick = GBH_ReputationBar_OnClick;  
   ---- Hook tooltip text
   ORIG_REPUTATION_MOVE_TO_INACTIVE = REPUTATION_MOVE_TO_INACTIVE;
   --    Hooking for error messages
   --GBH_orig_ChatFrame_MessageEventHandler = ChatFrame_MessageEventHandler;
   --ChatFrame_MessageEventHandler = GBH_ChatFrame_MessageEventHandler;
   
   --GBH_original_FriendsFrame_OnEvent = FriendsFrame_OnEvent;
   --FriendsFrame_OnEvent = GBH_FriendsFrame_OnEvent;
   
   --GBH_ReptabTextLabel1:SetText(L_GBH_VERSION..GBH_Version);
   -- GBH_UpdateRankText();
   --GBH_UpdateOptionsText();
   -- localization
   --GBH_Message(L_GBH_LOADED);
   --if GBH_OwnRank > 0 and GBH_OwnRank < 4 then 
   --   GBH_ModerateFrame_OnLoad(GBH_ModerateFrame);
   --end
   
   --GBH_ReptabTextLabel1:SetText(L_GBH_VERSION..GBH_Version);  
   
end

function GBH_GetStandingName(amount)
   amount = tonumber(amount);
   if amount < -6000 then
      -- localization menu
      return amount + 42000,36000, L_GBH_REP_L[0],1;
   elseif amount < -3000 then
      -- localization menu
      return amount + 6000,3000, L_GBH_REP_L[1],2;
   elseif amount < 0 then
      -- localization menu
      return amount + 3000,3000, L_GBH_REP_L[2],3;
   elseif amount < 3000 then
      -- localization menu
      return amount,3000, L_GBH_REP_L[3],4;
   elseif amount < 9000 then
      -- localization menu
      return amount - 3000,6000, L_GBH_REP_L[4],5;
   elseif amount < 21000 then
      -- localization menu
      return amount - 9000 ,12000, L_GBH_REP_L[5],6;
   elseif amount < 42000 then
      -- localization menu
      return amount - 21000,21000, L_GBH_REP_L[6],7;
   elseif amount < 43000 then
      -- localization menu
      return amount - 42000,1000,  L_GBH_REP_L[7],8;
   elseif amount >= 43000 then
      -- localization menu
      return 999,1000,  L_GBH_REP_L[7],8;
   else
      return 0,0,"",0;
   end
end

L_GBH_REP_L = {
   [0] = "hated",
   [1] = "hostile",
   [2] = "unfriendly",
   [3] = "neutral",
   [4] = "friendly",
   [5] = "honored",
   [6] = "revered",
   [7] = "exalted"
};

--GBH_FactionNum = 3;
GBH_BarMinValues = {
   [1] = {
      minValue = -42000,
      maxValue = -6000
   },
   [2] = {
      minValue = -6000,
      maxValue = -3000
   },
   [3] = {
      minValue = -3000,
      maxValue = 0
   },
   [4] = {
      minValue = 0,
      maxValue = 3000
   },
   [5] = {
      minValue = 3000,
      maxValue = 9000
   },
   [6] = {
      minValue = 9000,
      maxValue = 21000
   },
   [7] = {
      minValue = 21000,
      maxValue = 42000
   },
   [8] = {
      minValue = 42000,
      maxValue = 43000
   },
};


function GBH_SetReputation(index,newValue)
   
   if newValue > 42999 then
      newValue = 42999;
   end
   if newValue < -42000 then
      newValue = -42000;
   end
   
   GBH_FactionData[index].value = newValue;
   -- calc new standing ID 
   local calculated = false;
   for i=1,8 do
      if calculated == false then
         if GBH_BarMinValues[i].minValue <= newValue and GBH_BarMinValues[i].maxValue > newValue then
            GBH_FactionData[index].standingID = i;
            calculated = true;    
         end
      end
   end
   
   ReputationFrame_Update();
   ReputationWatchBar_Update();
end

--add rep for gold deposits
function GBH_AddLocalGoldRep(amount)
    --initial reps
    local irep1 = GBH_FactionData[2].value or 0
    local irep2 = GBH_FactionData[3].value or 0
    local irep3 = GBH_FactionData[4].value or 0
    local irep4 = GBH_FactionData[5].value or 0
    local irep5 = GBH_FactionData[6].value or 0
    
    --adjusted reps
    local arep1 = math.floor(amount*(GBL_GuildFactions[1].goldtorep or 0)/10000)
    local arep2 = math.floor(amount*(GBL_GuildFactions[2].goldtorep or 0)/10000)       
    local arep3 = math.floor(amount*(GBL_GuildFactions[3].goldtorep or 0)/10000)
    local arep4 = math.floor(amount*(GBL_GuildFactions[4].goldtorep or 0)/10000)
    local arep5 = math.floor(amount*(GBL_GuildFactions[5].goldtorep or 0)/10000)
    
    --total reps
    local trep1 = math.floor(irep1 + arep1)
    local trep2 = math.floor(irep2 + arep2)
    local trep3 = math.floor(irep3 + arep3)
    local trep4 = math.floor(irep4 + arep4)
    local trep5 = math.floor(irep5 + arep5)    
    
    --set reps
    GBH_SetReputation(2, trep1)
    GBH_SetReputation(3, trep2)
    GBH_SetReputation(4, trep3)
    GBH_SetReputation(5, trep4)
    GBH_SetReputation(6, trep5)
    
    --print reps
    if arep1 > 0 then
        GBL_LargessMessage("Reputation with "..GBH_FactionData[2].name.." increased by "..arep1..".", "rep")
    end
    if arep2 > 0 then
        GBL_LargessMessage("Reputation with "..GBH_FactionData[3].name.." increased by "..arep2..".", "rep")
    end
    if arep3 > 0 then
        GBL_LargessMessage("Reputation with "..GBH_FactionData[4].name.." increased by "..arep3..".", "rep")
    end
    if arep4 > 0 then
        GBL_LargessMessage("Reputation with "..GBH_FactionData[5].name.." increased by "..arep4..".", "rep")
    end
    if arep5 > 0 then
        GBL_LargessMessage("Reputation with "..GBH_FactionData[6].name.." increased by "..arep5..".", "rep")
    end    
        
end

--subtract rep for withdraws
function GBH_SubLocalGoldRep(amount)
    --initial reps
    local irep1 = GBH_FactionData[2].value or 0
    local irep2 = GBH_FactionData[3].value or 0
    local irep3 = GBH_FactionData[4].value or 0
    local irep4 = GBH_FactionData[5].value or 0
    local irep5 = GBH_FactionData[6].value or 0
    
    --adjusted reps
    local arep1 = math.floor(amount*(GBL_GuildFactions[1].goldtorep or 0)/10000)
    local arep2 = math.floor(amount*(GBL_GuildFactions[2].goldtorep or 0)/10000)      
    local arep3 = math.floor(amount*(GBL_GuildFactions[3].goldtorep or 0)/10000)
    local arep4 = math.floor(amount*(GBL_GuildFactions[4].goldtorep or 0)/10000)
    local arep5 = math.floor(amount*(GBL_GuildFactions[5].goldtorep or 0)/10000)
    
    --total reps
    local trep1 = math.floor(irep1 - arep1)
    local trep2 = math.floor(irep2 - arep2)
    local trep3 = math.floor(irep3 - arep3)
    local trep4 = math.floor(irep4 - arep4)
    local trep5 = math.floor(irep5 - arep5)    
    
    --set reps
    GBH_SetReputation(2, trep1)
    GBH_SetReputation(3, trep2)
    GBH_SetReputation(4, trep3)
    GBH_SetReputation(5, trep4)
    GBH_SetReputation(6, trep5)
    
    --print reps
    if arep1 > 0 then
        GBL_LargessMessage("Reputation with "..GBH_FactionData[2].name.." decreased by "..arep1..".", "rep")
    end
    if arep2 > 0 then
        GBL_LargessMessage("Reputation with "..GBH_FactionData[3].name.." decreased by "..arep2..".", "rep")
    end
    if arep3 > 0 then
        GBL_LargessMessage("Reputation with "..GBH_FactionData[4].name.." decreased by "..arep3..".", "rep")
    end
    if arep4 > 0 then
        GBL_LargessMessage("Reputation with "..GBH_FactionData[5].name.." decreased by "..arep4..".", "rep")
    end
    if arep5 > 0 then
        GBL_LargessMessage("Reputation with "..GBH_FactionData[6].name.." decreased by "..arep5..".", "rep")
    end    
end

--add rep for bounty claims
function GBH_AddLocalBountyRep(amount) 
    --initial reps
    local irep1 = GBH_FactionData[2].value or 0
    local irep2 = GBH_FactionData[3].value or 0
    local irep3 = GBH_FactionData[4].value or 0
    local irep4 = GBH_FactionData[5].value or 0
    local irep5 = GBH_FactionData[6].value or 0
    
    --adjusted reps
    local arep1 = amount*(GBL_GuildFactions[1].bountytorep or 0)/10000
    local arep2 = amount*(GBL_GuildFactions[2].bountytorep or 0)/10000       
    local arep3 = amount*(GBL_GuildFactions[3].bountytorep or 0)/10000
    local arep4 = amount*(GBL_GuildFactions[4].bountytorep or 0)/10000
    local arep5 = amount*(GBL_GuildFactions[5].bountytorep or 0)/10000
    
    --total reps
    local trep1 = irep1 + arep1
    local trep2 = irep2 + arep2
    local trep3 = irep3 + arep3
    local trep4 = irep4 + arep4
    local trep5 = irep5 + arep5    
    
    --set reps
    GBH_SetReputation(2, math.floor(trep1))
    GBH_SetReputation(3, math.floor(trep2))
    GBH_SetReputation(4, math.floor(trep3))
    GBH_SetReputation(5, math.floor(trep4))
    GBH_SetReputation(6, math.floor(trep5))
    
    --print reps
    if arep1 > 0 then
        GBL_LargessMessage("Reputation with "..GBH_FactionData[2].name.." increased by "..arep1..".", "rep")
    end
    if arep2 > 0 then
        GBL_LargessMessage("Reputation with "..GBH_FactionData[3].name.." increased by "..arep2..".", "rep")
    end
    if arep3 > 0 then
        GBL_LargessMessage("Reputation with "..GBH_FactionData[4].name.." increased by "..arep3..".", "rep")
    end
    if arep4 > 0 then
        GBL_LargessMessage("Reputation with "..GBH_FactionData[5].name.." increased by "..arep4..".", "rep")
    end
    if arep5 > 0 then
        GBL_LargessMessage("Reputation with "..GBH_FactionData[6].name.." increased by "..arep5..".", "rep")
    end    
end

function GBH_AddLocalItemRep(item,count)
     local name, link, quality, iLevel,  reqLevel, class, subclass, maxStack,  equipSlot, texture, vendorPrice = GetItemInfo(item)
     
    --initial reps
    local irep1 = GBH_FactionData[2].value or 0
    local irep2 = GBH_FactionData[3].value or 0
    local irep3 = GBH_FactionData[4].value or 0
    local irep4 = GBH_FactionData[5].value or 0
    local irep5 = GBH_FactionData[6].value or 0
    
    --adjusted reps
    local arep1, arep2, arep3, arep4, arep5 = GBL_GetFactionItemRep(link)
    arep1 = arep1*count
    arep2 = arep2*count
    arep3 = arep3*count
    arep4 = arep4*count
    arep5 = arep5*count
    
    --total reps
    local trep1 = irep1 + arep1
    local trep2 = irep2 + arep2
    local trep3 = irep3 + arep3
    local trep4 = irep4 + arep4
    local trep5 = irep5 + arep5    
    
    --set reps
    GBH_SetReputation(2, math.floor(trep1))
    GBH_SetReputation(3, math.floor(trep2))
    GBH_SetReputation(4, math.floor(trep3))
    GBH_SetReputation(5, math.floor(trep4))
    GBH_SetReputation(6, math.floor(trep5))
    
    --print reps
    if arep1 > 0 then
        GBL_LargessMessage("Reputation with "..GBH_FactionData[2].name.." increased by "..arep1..".", "rep")
    end
    if arep2 > 0 then
        GBL_LargessMessage("Reputation with "..GBH_FactionData[3].name.." increased by "..arep2..".", "rep")
    end
    if arep3 > 0 then
        GBL_LargessMessage("Reputation with "..GBH_FactionData[4].name.." increased by "..arep3..".", "rep")
    end
    if arep4 > 0 then
        GBL_LargessMessage("Reputation with "..GBH_FactionData[5].name.." increased by "..arep4..".", "rep")
    end
    if arep5 > 0 then
        GBL_LargessMessage("Reputation with "..GBH_FactionData[6].name.." increased by "..arep5..".", "rep")
    end    

end

function GBH_SubLocalItemRep(item,count)
     local name, link, quality, iLevel,  reqLevel, class, subclass, maxStack,  equipSlot, texture, vendorPrice = GetItemInfo(item)
     
    --initial reps
    local irep1 = GBH_FactionData[2].value or 0
    local irep2 = GBH_FactionData[3].value or 0
    local irep3 = GBH_FactionData[4].value or 0
    local irep4 = GBH_FactionData[5].value or 0
    local irep5 = GBH_FactionData[6].value or 0
    
    --adjusted reps
    local arep1, arep2, arep3, arep4, arep5 = GBL_GetFactionItemRep(link)
    arep1 = arep1*count
    arep2 = arep2*count
    arep3 = arep3*count
    arep4 = arep4*count
    arep5 = arep5*count
    
    --total reps
    local trep1 = irep1 - arep1
    local trep2 = irep2 - arep2
    local trep3 = irep3 - arep3
    local trep4 = irep4 - arep4
    local trep5 = irep5 - arep5    
    
    --set reps
    GBH_SetReputation(2, math.floor(trep1))
    GBH_SetReputation(3, math.floor(trep2))
    GBH_SetReputation(4, math.floor(trep3))
    GBH_SetReputation(5, math.floor(trep4))
    GBH_SetReputation(6, math.floor(trep5))
    
    --print reps
    if arep1 > 0 then
        GBL_LargessMessage("Reputation with "..GBH_FactionData[2].name.." decreased by "..arep1..".", "rep")
    end
    if arep2 > 0 then
        GBL_LargessMessage("Reputation with "..GBH_FactionData[3].name.." decreased by "..arep2..".", "rep")
    end
    if arep3 > 0 then
        GBL_LargessMessage("Reputation with "..GBH_FactionData[4].name.." decreased by "..arep3..".", "rep")
    end
    if arep4 > 0 then
        GBL_LargessMessage("Reputation with "..GBH_FactionData[5].name.." decreased by "..arep4..".", "rep")
    end
    if arep5 > 0 then
        GBL_LargessMessage("Reputation with "..GBH_FactionData[6].name.." decreased by "..arep5..".", "rep")
    end    

end

function GBH_DiscountTransByLocalRep(amount,ttype,item)
    --ttype is index into discount matrix
    -- 1: Money
    -- 2: Repair
    -- 3: Item
    -- 4: Bounty    
    local irep1 = 1
    local irep2 = 1
    local irep3 = 1
    local irep4 = 1
    local irep5 = 1
    local name1,name2,i
    
    if ttype == "withdraw" then 
        ttype = 1
    elseif ttype == "repair" then
        ttype = 2
    elseif ttype == "item" then
        ttype = 3
        for i = 1, #GBL_ItemLargess do
            name1 = GetItemInfo(GBL_ItemLargess[i].item)
            name2 = GetItemInfo(item)
            if name1 == name2 then
                --item exists in list
                if GBL_ItemLargess[i].rep1 == 0 then
                    irep1 = 0
                end
                if GBL_ItemLargess[i].rep2 == 0 then
                    irep2 = 0
                end
                if GBL_ItemLargess[i].rep3 == 0 then
                    irep3 = 0
                end
                if GBL_ItemLargess[i].rep4 == 0 then
                    irep4 = 0
                end
                if GBL_ItemLargess[i].rep5 == 0 then
                    irep5 = 0
                end                
            end
        end
    elseif ttype == "bounty" then
        ttype = 4
    end      
    
    local lvl01,lvl02,lvl03,lvl04,lvl05
    local disc = 0    
    
    local rep1 = GBH_FactionData[2].value or 0
    local rep2 = GBH_FactionData[3].value or 0
    local rep3 = GBH_FactionData[4].value or 0
    local rep4 = GBH_FactionData[5].value or 0
    local rep5 = GBH_FactionData[6].value or 0
    
    lvl01 = GBL_GrpToRepLevelNumber(rep1+42000)
    lvl02 = GBL_GrpToRepLevelNumber(rep2+42000)
    lvl03 = GBL_GrpToRepLevelNumber(rep3+42000)
    lvl04 = GBL_GrpToRepLevelNumber(rep4+42000)
    lvl05 = GBL_GrpToRepLevelNumber(rep5+42000)
    
    --gbh_debug("Rep1 level:"..lvl01)
    
    --add up discounts for all factions    
    disc = GBL_GuildFactions[1].discount[lvl01][ttype]*irep1
    disc = disc + GBL_GuildFactions[2].discount[lvl02][ttype]*irep2
    disc = disc + GBL_GuildFactions[3].discount[lvl03][ttype]*irep3
    disc = disc + GBL_GuildFactions[4].discount[lvl04][ttype]*irep4
    disc = disc + GBL_GuildFactions[5].discount[lvl05][ttype]*irep5
    
    return amount - floor(amount*(disc/100))
    
end