GBH_NUM_HITLIST_ENTRIES = 14
GBH_NUM_ITEMLARGESS_ENTRIES = 8
GBH_SelectedBounty = -1

----------------------
--  Minimap Button  --
----------------------
do
	local dragMode = nil
	
	local function moveButton(self)
		if dragMode == "free" then
			local centerX, centerY = Minimap:GetCenter()
			local x, y = GetCursorPosition()
			x, y = x / self:GetEffectiveScale() - centerX, y / self:GetEffectiveScale() - centerY
			self:ClearAllPoints()
			self:SetPoint("CENTER", x, y)
		else
			local centerX, centerY = Minimap:GetCenter()
			local x, y = GetCursorPosition()
			x, y = x / self:GetEffectiveScale() - centerX, y / self:GetEffectiveScale() - centerY
			centerX, centerY = math.abs(x), math.abs(y)
			centerX, centerY = (centerX / math.sqrt(centerX^2 + centerY^2)) * 80, (centerY / sqrt(centerX^2 + centerY^2)) * 80
			centerX = x < 0 and -centerX or centerX
			centerY = y < 0 and -centerY or centerY
			self:ClearAllPoints()
			self:SetPoint("CENTER", centerX, centerY)
		end
	end

	local button = CreateFrame("Button", "GBHMinimapButton", Minimap)
	button:SetHeight(32)
	button:SetWidth(32)
	button:SetFrameStrata("MEDIUM")
	button:SetPoint("CENTER", -65.35, -38.8)
	button:SetMovable(true)
	button:SetUserPlaced(true)
	button:SetNormalTexture("interface\\lootframe\\lootpanel-icon")
	button:SetPushedTexture("interface\\lootframe\\lootpanel-icon")
	--button:SetHighlightTexture("Interface\\Minimap\\UI-Minimap-ZoomButton-Highlight")

	button:SetScript("OnMouseDown", function(self, button)
		if IsShiftKeyDown() and IsAltKeyDown() then
			dragMode = "free"
			self:SetScript("OnUpdate", moveButton)
		elseif IsShiftKeyDown() then
			dragMode = nil
			self:SetScript("OnUpdate", moveButton)
        elseif button == "RightButton" then
            GBH_BuyBounty()
		end
	end)
	button:SetScript("OnMouseUp", function(self)
		self:SetScript("OnUpdate", nil)
	end)
	button:SetScript("OnClick", function(self, button)
		if IsShiftKeyDown() then return end        
        GBH_ToggleHitList()
	end)
	button:SetScript("OnEnter", function(self)
		GameTooltip_SetDefaultAnchor(GameTooltip, self)
		GameTooltip:SetText("Guild Bounty Hunter")
        GameTooltip:AddLine("Left Click to toggle GBH",1,1,1)
        GameTooltip:AddLine("Right Click to place a bounty",1,1,1)
        GameTooltip:AddLine("Shift+Click to move this button on the minimap",1,1,1)
        GameTooltip:AddLine("Shift+Alt+Click to move this button anywhere",1,1,1)
		GameTooltip:Show()
	end)
	button:SetScript("OnLeave", function(self)
		GameTooltip:Hide()
	end)

	function GBH_ToggleMinimapButton()
		self.Options.ShowMinimapButton = not self.Options.ShowMinimapButton
		if self.Options.ShowMinimapButton then
			button:Show()
		else
			button:Hide()
		end
	end

	function GBH_HideMinimapButton()
		return button:Hide()
	end
end

function GBH_ToggleHitList()
    if (GBH_HitListFrame:IsShown()) then
        GBH_HitListFrame:Hide();
    else
        GBH_HitListFrame:Show();
    end
end

function GBH_EntryOnClick(self)   
   local i = self.index
   local issuer = GBH_HitListFiltered[i].issuer
   local claimer = GBH_HitListFiltered[i].claimer
   local realm = GBH_HitListFiltered[i].realm
   local level = GBH_HitListFiltered[i].level
   local class = GBH_HitListFiltered[i].class
   local race = GBH_HitListFiltered[i].race
   local zone = GBH_HitListFiltered[i].zone
   local xcoord = GBH_HitListFiltered[i].xcoord
   local ycoord = GBH_HitListFiltered[i].ycoord
   local intelage = GBH_HitListFiltered[i].intelage
   local age
   
   if faction == nil then
      faction = "UKNOWN"
   end
   if realm == nil then
      realm = GetRealmName()
   end
   if zone == nil then
      zone = ""
   end   
   if xcoord == nil then
      xcoord = 0
   end
   if ycoord == nil then
      ycoord = 0
   end
   if intelage == nil then
      intelage = 0
   end
   if class == nil then
      class = ""
   end
   if race == nil then
      race = ""
   end
   if level == nil then
      level = ""
   end   
   
   --GBH_LargessMessage("Clicked Bounty ID:"..GBH_HitListFiltered[i].id)
   GBH_BountyDetails_issuer:SetText(issuer)
   GBH_BountyDetails_claimer:SetText(claimer)
   GBH_BountyDetails_realm:SetText(realm)
   GBH_BountyDetails_class:SetText(level.." "..race.." "..class)
   if zone == nil or zone == "" then
      GBH_BountyDetails_zone:SetText("")
   else
      --GBH_BountyDetails_zone:SetText(zone.." ("..xcoord..","..ycoord..")")
      GBH_BountyDetails_zone:SetText(zone)
   end   
   if intelage > 0 then
      age = SecondsToTime(time()-intelage)
      GBH_BountyDetails_intelage:SetText(age.." ago")
   else
      GBH_BountyDetails_intelage:SetText("")
   end
   
   
   GBH_SelectedBounty = i
   GBH_SelectedBountyId = GBH_HitListFiltered[i].id
   GBH_HitListUpdate()
end   

--tooltip for hit list entry 
function GBH_EnterHitListEntry(self)   
   local i = self.index
   local issuer = GBH_HitListFiltered[i].issuer
   local claimer = GBH_HitListFiltered[i].claimer
   local realm = GBH_HitListFiltered[i].realm
   local level = GBH_HitListFiltered[i].level
   local class = GBH_HitListFiltered[i].class
   local race = GBH_HitListFiltered[i].race
   local zone = GBH_HitListFiltered[i].zone
   local xcoord = GBH_HitListFiltered[i].xcoord
   local ycoord = GBH_HitListFiltered[i].ycoord
   local intelage = GBH_HitListFiltered[i].intelage
   local name = GBH_HitListFiltered[i].name   
   
   if faction == nil then
      faction = "UKNOWN"
   end
   if realm == nil then
      realm = GetRealmName()
   end
   if zone == nil then
      zone = ""
   end   
   if xcoord == nil then
      xcoord = 0
   end
   if ycoord == nil then
      ycoord = 0
   end
   if intelage == nil then
      intelage = 0
   end
   if class == nil then
      class = ""
   end
   if race == nil then
      race = ""
   end
   if level == nil then
      level = ""
   end   
   
    --GBH_LargessMessage("Clicked Bounty ID:"..GBH_HitListFiltered[i].id)
    GameTooltip_SetDefaultAnchor(GameTooltip, self)
    local namestr = name
    if realm ~= nil and realm ~= "" and realm ~= GetRealmName() then
        namestr = namestr.."-"..realm
    end
    GameTooltip:SetText(namestr)
    local str = "" 
    if level ~= nil and level ~= "" then
        str = "Level "..level.." "
    end
    if race ~= nil and race ~= "" then
        str = str..race.." "
    end
    if class ~= nil and class ~= "" then
        str = str..GBH_FormatClassName(class)
    end  
    if str ~= "" then
        GameTooltip:AddLine(str,1,1,1)
    end
    if zone ~= nil and zone ~= "" and intelage ~= nil then
        if intelage ~= nil and intelage > 0 then
            local age = SecondsToTime(time()-intelage)
            GameTooltip:AddLine("Last seen in "..zone.." "..age.." ago",1,1,1)
        end
    end
    GameTooltip:AddLine("Issued by: "..issuer,1,1,1)
    GameTooltip:AddLine("Claimed by: "..claimer,1,1,1)    
    GameTooltip:Show()
end  

function GBH_FormatClassName(class)
    if class == "DEATHKNIGHT" then
        return "Death Knight"
    elseif class == "DRUID" then
        return "Druid"
    elseif class == "HUNTER" then
        return "Hunter"
    elseif class == "MAGE" then
        return "Mage"
    elseif class == "ROGUE" then
        return "Rogue"
    elseif class == "SHAMAN" then
        return "Shaman"
    elseif class == "PALADIN" then
        return "Paladin"
    elseif class == "PRIEST" then
        return "Priest"
    elseif class == "WARLOCK" then
        return "Warlock"
    elseif class == "WARRIOR" then
        return "Warrior"
    else
        return class
    end
end

function GBH_ExitHitListEntry(self)
    GameTooltip:Hide()
end

function GBH_CreateGUI()
   local i,frame,textString,moneyFrame   
   
   --Set Column Header Widths (kludgey adaptation to 4.0.1 guild roster)
   --bounty list
   GBH_ColumnHeaderFactionMiddle:SetWidth(31-9)
   GBH_ColumnHeaderNameMiddle:SetWidth(110-9)
   GBH_ColumnHeaderStateMiddle:SetWidth(32-9)
   GBH_ColumnHeaderBountyMiddle:SetWidth(140-9)
   --largess view
   GBH_ColumnHeaderGuildieMiddle:SetWidth(150-9)
   GBH_ColumnHeaderLargessMiddle:SetWidth(161-9)
   --item largess view
   GBH_ColumnHeaderItemMiddle:SetWidth(150-9)
   GBH_ColumnHeaderItemLargessMiddle:SetWidth(161-9)
   
   --faction view
   GBH_FactionColumnHeaderGuildieMiddle:SetWidth(150-9)
   GBH_FactionColumnHeaderReputationMiddle:SetWidth(161-9)
      
   --GBH_UIFrame:SetScript("OnShow",GBH_UIShow)   
   GBH_ListFrame:EnableMouse()
   GBH_ListFrame:EnableMouseWheel(1)   
   GBH_ListFrame:SetScript("OnShow",GBH_HitListUpdate) 
   GBH_ListFrame:Show()   
   MoneyFrame_Update(GBH_LargessAmountFrame, GBL_Largess); 
   GBH_LargessAmountFrame:SetScript("OnUpdate",function() GBH_GuiUpdate() end)
   
   --List Entry Frames (faux scroll frames)
   for i = 0,GBH_NUM_HITLIST_ENTRIES-1 do       
      frame = CreateFrame("Button","GBH_ListEntry"..i,GBH_ListFrame,"GBH_EntryTemplate")
      frame:SetPoint("TOPLEFT",0,-i*17)
      frame:Show() 
   end 
   GBH_ListEntryNormalTexture = frame:GetNormalTexture()
   GBH_UIFrame:SetPoint("TOPLEFT",-5,2)
   GBH_LargessViewFrame:SetPoint("TOPLEFT",5,2)
   GBH_LargessDetails:SetScript("OnUpdate",function() GBH_RosterLargessUpdate() end)
   GBH_FactionViewFrame:SetPoint("TOPLEFT",5,2)
   
   -- set add bounty quantity default
   GBH_AddBountyFrameQtBox:SetText("1");
   
   --gray out audit button if not officer
   if GBL_GetAdminLevel() < GBH_ADMIN then
        --AuditButtonIcon:SetDesaturated(true)
    end
end

function GBH_HitListUpdate()
   local i,dataOffset,offset,n,m
   local moneyFrame,textString,entryFrame,statusFrameTexture,factionTexture  
   
   GBH_FilterHitList()
   n = #GBH_HitListFiltered     
   FauxScrollFrame_Update(GBH_ListFrame,n,GBH_NUM_HITLIST_ENTRIES,17,nil,nil,nil,nil,nil,nil,true);
   offset = FauxScrollFrame_GetOffset(GBH_ListFrame);
   
   for i = 0,GBH_NUM_HITLIST_ENTRIES-1 do
      dataOffset = offset + i + 1      
      textString = _G["GBH_ListEntry"..i.."_TargetName"]
      moneyFrame = _G["GBH_ListEntry"..i.."_BountyAmount"]
      statusFrameTexture = _G["GBH_ListEntry"..i.."_BountyStatusTexture"]
      factionTexture = _G["GBH_ListEntry"..i.."_TargetFactionTexture"]
      entryFrame = _G["GBH_ListEntry"..i]
      
      if entryFrame == nil or factionTexture == nil or moneyFrame == nil or textString == nil then
        return
      end
      
      if dataOffset <= n then         
         --set faction image
         if (GBH_HitListFiltered[dataOffset].faction) == "UNKNOWN" then
            --factionTexture:SetTexture("interface\\gossipframe\\activequesticon")
            factionTexture:Hide()
            --factionTexture:Show()
         elseif (GBH_HitListFiltered[dataOffset].faction) == "Horde" then
            factionTexture:SetTexture("interface\\targetingframe\\ui-pvp-horde.blp")
            factionTexture:Show()
         elseif (GBH_HitListFiltered[dataOffset].faction) == "Alliance" then
            factionTexture:SetTexture("interface\\targetingframe\\ui-pvp-alliance.blp")
            factionTexture:Show()
         else
            if factionTexture ~= nil then
                factionTexture:Hide()
            end
         end
         --set status image
        if (GBH_HitListFiltered[dataOffset].state == "GBH_OPEN" or               
            GBH_HitListFiltered[dataOffset].state == "GBH_OPEN_L" ) then
            statusFrameTexture:SetTexture("interface\\minimap\\tracking\\Auctioneer.blp")
        elseif (GBH_HitListFiltered[dataOffset].state == "GBH_CLAIMED") then
            statusFrameTexture:SetTexture("interface\\lootframe\\lootpanel-icon")
        elseif (GBH_HitListFiltered[dataOffset].state == "GBH_OPEN_S" or
            GBH_HitListFiltered[dataOffset].state == "GBH_OPEN_SL") then
            statusFrameTexture:SetTexture("interface\\minimap\\tracking\\Banker.blp")
        end
         --set bounty money
         MoneyFrame_Update(moneyFrame, GBH_HitListFiltered[dataOffset].amount);
         --set target name
         textString:SetText(GBH_HitListFiltered[dataOffset].name)
         entryFrame.index = dataOffset
         if GBH_SelectedBounty == dataOffset then
            --set selected texture            
            entryFrame:LockHighlight()
         else
             --reset normal texture
            entryFrame:UnlockHighlight()
         end        
         entryFrame:Show()         
      else
         entryFrame:Hide()                
      end        
   end    
end

function GBH_CreateFriendsTab()   
   FriendsFrameTab6 = CreateFrame("Button", "FriendsFrameTab" ..6, FriendsFrame, "FriendsFrameTabTemplate");
   FriendsFrameTab6:SetPoint("LEFT", "FriendsFrameTab" .. 5, "RIGHT", -14, 0);
   FriendsFrameTab6:SetID(6);
   PanelTemplates_SetNumTabs(FriendsFrame, 6);
   PanelTemplates_UpdateTabs(FriendsFrame);
   FriendsFrameTab6:SetPoint("LEFT", "FriendsFrameTab" .. 5, "RIGHT", -14, 0);
   FriendsFrameTab6:SetText("GBH")
   TabID = 6

   -- add ourself to the subframe list....
   tinsert(FRIENDSFRAME_SUBFRAMES, "GBH_UIFrame");

   hooksecurefunc("FriendsFrame_Update", GBH_FriendsFrame_Update);
end

function GBH_FriendsFrame_Update()
   if(FriendsFrame.selectedTab == 6) then
      FriendsFrameTitleText:SetText("Guild Bounty Hunter");
      if(GBH_UIFrame:IsVisible()) then
         return;
      end
      FriendsFrameTopLeft:SetTexture("Interface\\ClassTrainerFrame\\UI-ClassTrainer-TopLeft");
      FriendsFrameTopRight:SetTexture("Interface\\ClassTrainerFrame\\UI-ClassTrainer-TopRight");
      FriendsFrameBottomLeft:SetTexture("Interface\\FriendsFrame\\GuildFrame-BotLeft");      
      FriendsFrameBottomRight:SetTexture("Interface\\FriendsFrame\\GuildFrame-BotRight");
      
      --GBH_UIFrame:ScrollFrameUpdate();
      GBH_UIFrame:SetParent("FriendsFrame");
      GBH_UIFrame:SetAllPoints();
      GBH_UIFrame:Show();
      
      FriendsFrame_ShowSubFrame("NonExistingFrame"); -- so all friendframe tabs get hidden  
      FriendsFrame_ShowSubFrame("GBH_UIFrame")
   end
end

function GBH_DelayScript(script,delay,id)   
   if id == nil then
      id = "GBH_TimerFrame"
   else
      id = "GBH_TimerFrame"..id
   end
   local f = CreateFrame("Frame",id,UIParent)
   local stop = time() + delay
   f:SetScript("OnUpdate",function() GBH_TimerUpdate(stop,f,script) end)   
end

function GBH_TimerUpdate(stop,self,script)   
   local t = time()    
   if t >= stop then       
      self:SetScript("OnUpdate",nil)
      RunScript(script)
   end   
end

function GBH_SortByName(a,b)    
   if GBH_NAME_SORT then      
      return a.name > b.name
   else      
      return a.name < b.name
   end
end
   
function GBH_SortByAmount(a,b)   
   if GBH_AMOUNT_SORT then
      return tonumber(a.amount) > tonumber(b.amount)   
   else
      return tonumber(a.amount) < tonumber(b.amount) 
   end
end

function GBH_SortByFaction(a,b)
   if a.faction == nil or a.faction == "NPC" then
      return false
   elseif b.faction == nil or b.faction == "NPC" then
      return true
   elseif GBH_FACTION_SORT then
      return a.faction > b.faction
   else
      return a.faction < b.faction
   end
end

function GBH_SortByState(a,b)
   if GBH_STATE_SORT then
      return a.state > b.state
   else
      return a.state < b.state
   end
end

function GBH_FilterHitList()
   local i,name,amount,id,issuer,timestamp,state,claimer,audit,faction,realm,zone,xcoord,ycoord,intelage,class,race,level
   local n = #GBH_HitList
   GBH_HitListFiltered = {}
   
   for i = 1,n do
      name = GBH_HitList[i].name
      amount = GBH_HitList[i].amount   
      id = GBH_HitList[i].id      
      issuer = GBH_HitList[i].issuer
      timestamp = GBH_HitList[i].timestamp
      state = GBH_HitList[i].state
      claimer = GBH_HitList[i].claimer  
      audit = GBH_HitList[i].audit
      faction = GBH_HitList[i].faction
      realm = GBH_HitList[i].realm
      zone = GBH_HitList[i].zone
      xcoord = GBH_HitList[i].xcoord
      ycoord = GBH_HitList[i].ycoord
      intelage = GBH_HitList[i].intelage
      class = GBH_HitList[i].class
      race = GBH_HitList[i].race
      level = GBH_HitList[i].level
      
      if (not GBH_FilterFormCheckShowHorde:GetChecked() and faction == "Horde") or
         (not GBH_FilterFormCheckShowAlliance:GetChecked() and faction == "Alliance") or
         (not GBH_FilterFormCheckShowOpen:GetChecked() and state == "GBH_OPEN") or 
         (not GBH_FilterFormCheckShowClaimed:GetChecked() and state == "GBH_CLAIMED") or
         (state == "GBH_DEL") then   
         --do nothing, could self logic be better? seriously
      else
         table.insert(GBH_HitListFiltered,{id=id,name=name,amount=amount,issuer=issuer,timestamp=timestamp,state=state,claimer=claimer,audit=audit,faction=faction,realm=realm,zone=zone,xcoord=xcoord,ycoord=ycoord,intelage=intelage,class=class,race=race,level=level});
      end 
   end
end

function GBH_GuiUpdate()     
    if GBL_Largess == nil then
        return
    end
    local largess = GBL_Largess 
    if largess < 0 then 
      largess = abs(largess)
      GBH_NegLargess:Show()
    else 
      GBH_NegLargess:Hide()
    end
      --GBL_LargessMessage(largess)
      MoneyFrame_Update(GBH_LargessAmountFrame, largess);      
end

function GBH_EnterBountyListButton(self)
    --GameTooltip_SetDefaultAnchor(GameTooltip,UIParent)
    GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT")
    GameTooltip:ClearLines()
    GameTooltip:AddLine("Bounty List")
    GameTooltip:AddLine("View the list of guild bounties",1,1,1)
    GameTooltip:Show()
end

function GBH_LeaveBountyListButton()
    GameTooltip:Hide()
end

function GBH_DisplayBountyList()     
    GBH_LargessViewFrame:Hide() 
    GBH_ItemLargessFrame:Hide()
    GBH_FactionViewFrame:Hide()
    --GBH_FactionDetailsScrollFrame:Hide()
    GBH_UIFrame:Show()  
    
    --set portrait icon
    SetPortraitToTexture(GBH_HitListFrameSkullnXBonesTexture,"interface\\icons\\inv_misc_book_06")
    --GBH_HitListFrameSkullnXBones:SetFrameStrata("BACKGROUND")
end

function GBH_EnterItemButton(self)
    --GameTooltip_SetDefaultAnchor(GameTooltip,UIParent)
    GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT")
    GameTooltip:ClearLines()
    GameTooltip:AddLine("Guild Bank Item Price List")
    GameTooltip:AddLine("Set the price for guild bank items",1,1,1)
    GameTooltip:Show()
end

function GBH_LeaveItemButton()
    GameTooltip:Hide()
end

function GBH_DisplayItemLargess()
    GBH_LargessViewFrame:Hide()      
    GBH_UIFrame:Hide()   
    GBH_ItemLargessFrame:Show()
    GBH_FactionViewFrame:Hide()
    
    --set portrait icon
    SetPortraitToTexture(GBH_HitListFrameSkullnXBonesTexture,"interface\\icons\\inv_ingot_03")
    --GBH_HitListFrameSkullnXBones:SetFrameStrata("BACKGROUND")   
end

function GBH_EnterLargessReportButton(self)  
    --GameTooltip_SetDefaultAnchor(GameTooltip,UIParent)
    GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT")
    GameTooltip:ClearLines()
    GameTooltip:AddLine("Guild Bank Balance Report")
    GameTooltip:AddLine("A list of bank balances for all guild members",1,1,1)
    GameTooltip:Show()
end

function GBH_LeaveLargessReportButton()
    GameTooltip:Hide()
end   

function GBH_EnterIntelButton(self)
    --GameTooltip_SetDefaultAnchor(GameTooltip,UIParent)
    GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT")
    GameTooltip:ClearLines()
    GameTooltip:AddLine("Gather Intelligence")
    GameTooltip:AddLine("Spy on bounty targets of either faction",1,1,1)
    GameTooltip:Show()
end

function GBH_LeaveIntelButton()
    GameTooltip:Hide()
end

function GBH_EnterListButton()
    GameTooltip_SetDefaultAnchor(GameTooltip,UIParent)
    GameTooltip:ClearLines()
    GameTooltip:AddLine("List Bounties")
    GameTooltip:AddLine("Display the bounty list to guild chat",1,1,1)
    GameTooltip:Show()
end

function GBH_LeaveListButton()
    GameTooltip:Hide()
end

function GBH_EnterFactionViewButton(self)
    --GameTooltip_SetDefaultAnchor(GameTooltip,UIParent)
    GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT")
    GameTooltip:ClearLines()
    GameTooltip:AddLine("Guild Factions")
    GameTooltip:AddLine("List member reputations with each guild faction",1,1,1)
    GameTooltip:Show()
end

function GBH_LeaveFactionViewButton()
    GameTooltip:Hide()
end

function GBH_EnterFactionDetailsButton()
    GameTooltip_SetDefaultAnchor(GameTooltip,UIParent)
    GameTooltip:ClearLines()
    GameTooltip:AddLine("Guild Faction Details")
    GameTooltip:AddLine("Toggle between member reputation and guild faction details",1,1,1)
    GameTooltip:Show()
end

function GBH_LeaveFactionDetailsButton()
    GameTooltip:Hide()
end

function GBH_EnterAuditButton(self)
    --GameTooltip_SetDefaultAnchor(GameTooltip,UIParent)
    GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT")
    GameTooltip:ClearLines()
    GameTooltip:AddLine("Audit Guild Bank")
    GameTooltip:AddLine("Open the guild bank logs and audit all transactions",1,1,1)
    GameTooltip:Show()
end

function GBH_LeaveAuditButton()
    GameTooltip:Hide()
end

function GBH_EnterConfigButton(self)
    --GameTooltip_SetDefaultAnchor(GameTooltip,UIParent)
    GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT")
    GameTooltip:ClearLines()
    GameTooltip:AddLine("Configuration")
    GameTooltip:AddLine("Change some GBH settings",1,1,1)
    GameTooltip:Show()
end

function GBH_LeaveConfigButton()
    GameTooltip:Hide()
end

function GBH_IntelOnClick()
    if GBH_IntelList == nil then
        GBH_IntelPost()
        StaticPopup_Show("INTEL_POST")   
    else
        StaticPopup_Show("INTEL_SPY")
    end
end

function GBH_LargessReportButtonOnClick()
    GBH_UIFrame:Hide()  
    GBH_ItemLargessFrame:Hide()
    GBH_LargessViewFrame:Show() 
    GBH_FactionViewFrame:Hide()
    GBH_LargessAmountFrame:Show()
    GBH_AddBountyButton:Show()
    GBH_HitListFrameTexture1:Show()
    
    --set portrait icon
    SetPortraitToTexture(GBH_HitListFrameSkullnXBonesTexture,"interface\\icons\\inv_misc_coin_02")
    --GBH_HitListFrameSkullnXBones:SetFrameStrata("BACKGROUND")   
end

function GBH_CreateLargessView()
   local i,frame,textString,moneyFrame   
   
   --GBH_UIFrame:SetScript("OnShow",GBH_UIShow)   
   GBH_LargessScrollFrame:EnableMouse()
   GBH_LargessScrollFrame:EnableMouseWheel(1)   
   GBH_LargessScrollFrame:SetScript("OnShow",GBH_LargessFrameUpdate) 
   GBH_LargessScrollFrame:Show()   
   MoneyFrame_Update(GBH_LargessAmountFrame, GBL_Largess); 
   
   --List Entry Frames (faux scroll frames)
   for i = 0,GBH_NUM_HITLIST_ENTRIES-1 do       
      frame = CreateFrame("Button","GBH_LargessEntry"..i,GBH_LargessScrollFrame,"GBH_LargessEntryTemplate")
      frame:SetPoint("TOPLEFT",0,-i*17)
      frame:Show() 
   end 
   GBH_ListEntryNormalTexture = frame:GetNormalTexture()
   GBH_LargessScrollFrame:SetPoint("TOPLEFT",10,-100) 
   GBH_LargessCurrentEntry = 0
   MoneyFrame_Update(GBH_RosterMoneyFrame, 0); 
   
end  

function GBL_SetupLargessViewList()
    local i, name, largess
    
    GBL_LargessViewList = {}
    for i= 1, #GBL_GuildMates do
        name = GBL_GuildMates[i].name
        largess = GBL_AuditData[name].largess
        table.insert(GBL_LargessViewList, {name=name, largess=largess})
    end
    
    if GBL_SORT_LARGESS_VIEW == "LARGESS" then
        table.sort(GBL_LargessViewList,GBH_SortByGuildieLargess)
    elseif GBL_SORT_LARGESS_VIEW == "GUILDIE" then
        table.sort(GBL_LargessViewList,GBH_SortByGuildie)
    end
end

function GBH_LargessFrameUpdate()
    local i,dataOffset,offset,n,m
    local moneyFrame,textString,entryFrame,negLargess  
    
    GBL_SetupLargessViewList()
    n = #GBL_LargessViewList
    FauxScrollFrame_Update(GBH_LargessScrollFrame,n,GBH_NUM_HITLIST_ENTRIES,17,nil,nil,nil,nil,nil,nil,true);
    offset = FauxScrollFrame_GetOffset(GBH_LargessScrollFrame);
       
    for i = 0,GBH_NUM_HITLIST_ENTRIES-1 do
        dataOffset = offset + i + 1      
        textString = _G["GBH_LargessEntry"..i.."_GuildieName"]
        moneyFrame = _G["GBH_LargessEntry"..i.."_LargessAmount"]
        negLargess = _G["GBH_LargessEntry"..i.."_LargessAmount_NegGuildieLargess"]
        entryFrame = _G["GBH_LargessEntry"..i]      
        if dataOffset <= n then   
            --set bounty money
            MoneyFrame_Update(moneyFrame, abs(GBL_LargessViewList[dataOffset].largess));
            if GBL_LargessViewList[dataOffset].largess < 0 then
                negLargess:Show()
                textString:SetTextColor(1,0,0)
            else
                textString:SetTextColor(1,0.81,0)
                negLargess:Hide()
            end
            --set target name
            textString:SetText(GBL_LargessViewList[dataOffset].name)
            entryFrame.index = dataOffset
            if GBH_LargessCurrentEntry == dataOffset then
                --set selected texture            
                entryFrame:LockHighlight()
            else
                --reset normal texture
                entryFrame:UnlockHighlight()
            end        
            entryFrame:Show()         
        else
            entryFrame:Hide()                
        end        
    end    
end

function GBH_LargessEntryOnClick(self)
    GBH_LargessCurrentEntry = self.index
    --GBL_LargessMessage(i)
    
end

function GBH_RosterLargessUpdate()     
   local i = GBH_LargessCurrentEntry    
   if GBL_GuildMates == nil or GBL_AuditData == nil then
        return
   end
   if i > 0 then  
      GuildRoster()
      GBL_AuditInit()
      GBL_AuditLoad()
      --GBL_SetupLargessViewList()
      GBH_LargessFrameUpdate()
      local largess = GBL_LargessViewList[i].largess 
      if largess < 0 then 
         largess = abs(largess)
         GBH_NegRosterLargess:Show()
      else 
         GBH_NegRosterLargess:Hide()
      end
      --GBL_LargessMessage(largess)
      MoneyFrame_Update(GBH_RosterMoneyFrame, largess);      
   end
end

function GBH_RosterLargessAdd()  
   if GBL_GetAdminLevel() < GBL_ADMIN then
        GBL_LargessMessage("You do not have permission to adjust Largess.")
        return
   end
   local i = GBH_LargessCurrentEntry     
   local name = GBL_LargessViewList[i].name
   local add = MoneyInputFrame_GetCopper(GBH_LargessModFrame)  
   local base = GBL_LargessViewList[i].largess   
   GBL_SetLargess(name,base+add)
   local moneystr = GBL_CopperToGold(add)
   GBL_LargessMessage(moneystr.." added to "..name.."'s Largess.") 
   --GBL_SetupLargessViewList()
end
   
 function GBH_RosterLargessSub()  
    if GBL_GetAdminLevel() < GBL_ADMIN then
        GBL_LargessMessage("You do not have permission to adjust Largess.")
        return
   end
   local i = GBH_LargessCurrentEntry     
   local name = GBL_LargessViewList[i].name
   local sub = MoneyInputFrame_GetCopper(GBH_LargessModFrame)  
   local base = GBL_LargessViewList[i].largess   
   GBL_SetLargess(name,base-sub)
   local moneystr = GBL_CopperToGold(sub)
   GBL_LargessMessage(moneystr.." subtracted from "..name.."'s Largess.","red") 
   --GBL_SetupLargessViewList()
end 

function GBH_RosterLargessEq()   
    if GBL_GetAdminLevel() < GBL_ADMIN then
        GBL_LargessMessage("You do not have permission to adjust Largess.")
        return
    end
   local i = GBH_LargessCurrentEntry     
   local name = GBL_LargessViewList[i].name
   local set = MoneyInputFrame_GetCopper(GBH_LargessModFrame)    
   GBL_SetLargess(name,set)
   local moneystr = GBL_CopperToGold(set)
   GBL_LargessMessage(name.."'s Largess set to "..moneystr) 
   --GBL_SetupLargessViewList()
end

-- Add Bounty Frame
function GBH_AddBountyFrameOnShow(self, data, data2)
    local name = UnitName("target")    
    local money = MoneyInputFrame_GetCopper(GBH_AddBountyFrameTotalAmount)       
    if name then GBH_AddBountyFrameNameBox:SetText(name) end
    if (money > 0 and (name ~= "" or GBH_AddBountyFrameCheckBG:GetChecked())) then
        GBH_AddBountyFramePlaceBounties:Enable()
    else
        GBH_AddBountyFramePlaceBounties:Disable()
    end      
end

function GBH_AddBountyFrameOnUpdate(self, elapsed)
    local name = GBH_AddBountyFrameNameBox:GetText()    
    local money = MoneyInputFrame_GetCopper(GBH_AddBountyFrameAmount)       
         
    if (money > 0 and (name ~= "" or GBH_AddBountyFrameCheckBG:GetChecked())) then
        GBH_AddBountyFramePlaceBounties:Enable()
    else
        GBH_AddBountyFramePlaceBounties:Disable()
    end 
    
    if GBH_AddBountyFrameCheckBG:GetChecked() then       
        GBH_AddBountyFrameNameBox:Hide()        
    else
        GBH_AddBountyFrameNameBox:Show()        
    end     
    
    local quantity = GBH_AddBountyFrameQtBox:GetText()
    quantity = tonumber(quantity)
    if quantity ~= nil then
        local amount = MoneyInputFrame_GetCopper(GBH_AddBountyFrameAmount)
        amount = GBH_DiscountTransByLocalRep(amount,4)
        MoneyInputFrame_SetCopper(GBH_AddBountyFrameTotalAmount, amount*quantity)
    end    
end

function GBH_AddBountyFrameOnAccept(self)
    local name = GBH_AddBountyFrameNameBox:GetText()
    local money = MoneyInputFrame_GetCopper(GBH_AddBountyFrameTotalAmount)
    local quantity = GBH_AddBountyFrameQtBox:GetText()
    local amount = MoneyInputFrame_GetCopper(GBH_AddBountyFrameAmount)
    local split = GBH_AddBountyFrameCheckSR:GetChecked()
    local lock = GBH_AddBountyFrameCheckOL:GetChecked()
    local bg = GBH_AddBountyFrameCheckBG:GetChecked()
    local i
    
    --apply any faction discounts
    local cost = GBH_DiscountTransByLocalRep(amount,4)
    
    --GBL_LargessMessage("Accept")
    quantity = tonumber(quantity)
    
    if quantity == nil then 
        return             
    end  
    
    for i = 1, quantity do
        gbh_debug(cost..":"..GBL_Largess)
        if bg then
            GBH_AddBGBounties(amount,split,lock,i)
        elseif GBL_Largess >= cost then
            GBH_AddBounty(name, amount, nil, nil, nil, nil, split, lock, i)            
        else
            GBL_LargessMessage("You do not have enough largess.","red")
            GBL_LargessMessage("Please deposit gold into the guild bank.","red")  
            return
        end  
    end
end

--hit list bounty filters menu
function GBH_BountyFilterDropDownOnLoad(self)
    UIDropDownMenu_Initialize(self, GBH_BountyFilterMenuInitialize)
end

function GBH_BountyFilterMenuInitialize(level)
    --GBL_LargessMessage("Faction Init") 
    GBH_BountyFilterMenu:SetScript("OnClick", GBH_BountyFilterMenuOnClick)
    
    local info ={}
    info.text = "Show Alliance"    
    info.icon = "INTERFACE/BUTTONS/UI-CHECKBOX-CHECK"
    if UIDropDownMenu_GetSelectedValue(GBH_BountyFilterMenu) == "Show Alliance" then
        info.checked = true
    else
        info.checked = nil
    end
    info.func = GBH_BountyFilterItemClick
    UIDropDownMenu_AddButton(info)
    
    info ={}
    info.text = "Show Horde"
    if UIDropDownMenu_GetSelectedValue(GBH_BountyFilterMenu) == "Show Horde" then
        info.checked = true
    else
        info.checked = nil
    end
    info.func = GBH_BountyFilterItemClick
    UIDropDownMenu_AddButton(info)
    
    info ={}
    info.text = "Show Open"
    if UIDropDownMenu_GetSelectedValue(GBH_BountyFilterMenu) == "Show Open" then
        info.checked = true
    else
        info.checked = nil
    end
    info.func = GBH_BountyFilterItemClick
    UIDropDownMenu_AddButton(info)
    
    info ={}
    info.text = "Show Claimed"
    if UIDropDownMenu_GetSelectedValue(GBH_BountyFilterMenu) == "Show Claimed" then
        info.checked = true
    else
        info.checked = nil
    end
    info.func = GBH_BountyFilterItemClick
    UIDropDownMenu_AddButton(info)
    
    info ={}
    info.text = "Faction 5"
    if UIDropDownMenu_GetSelectedValue(GBH_BountyFilterMenu) == "Faction 5" then
        info.checked = true
    else
        info.checked = nil
    end
    info.func = GBH_BountyFilterItemClick
    UIDropDownMenu_AddButton(info)      
end

function GBH_BountyFilterMenuOnClick(self)
    --GBL_LargessMessage("Faction Click...")
    ToggleDropDownMenu(1, nil, GBH_FactionRepDropDownFrame, self:GetName(), -100, 0)
end

function GBH_BountyFilterItemClick(self)    
    GBL_LargessMessage(self.value)
    UIDropDownMenu_SetSelectedValue(GBH_BountyFilterMenu, self.value)    
    --GBH_FactionFrameUpdate()
end