function GBH_EnterItemLargessIconButton()
    GameTooltip_SetDefaultAnchor(GameTooltip,UIParent)
    GameTooltip:ClearLines()
    if GBH_CurrentItemLargessIconItem ~= nil then
        GameTooltip:SetHyperlink(GBH_CurrentItemLargessIconItem)
        GameTooltip:Show()
    end
end

function GBH_LeaveItemLargessIconButton()
    GameTooltip:Hide()
end

function GBH_AddItemToLargessList(item, value)
    if GBL_ItemLargess == nil then
        GBL_ItemLargess = {}
    end 
    
    --prevent duplicate entries
    local i, name1, name2, argflag
    local faction = UIDropDownMenu_GetSelectedID(GBH_ItemFactionSelectMenu) or 1
    
    if item == nil then
        --not using arguments
        argflag = false
        item = GBH_CurrentItemLargessIconItem
        name2 = GetItemInfo(GBH_CurrentItemLargessIconItem)
        value = MoneyInputFrame_GetCopper(GBH_ItemLargessMoneyFrame)         
    else
        --using arguments
        argflag = true
        name2 = GetItemInfo(item)         
    end
    
    --search for item in list to avoid duplicate entries
    for i = 1, #GBL_ItemLargess do
        name1 = GetItemInfo(GBL_ItemLargess[i].item)
        --name2 = GetItemInfo(GBH_CurrentItemLargessIconItem)
        gbh_debug(name1.." : "..name2)
        if name1 == name2 then    
            gbh_debug(name1.." exists!")
            
            if argflag then 
                return 
            end
            
            --existing item
            if faction == 1 then
                GBL_ItemLargess[i].rep1 = tonumber(GBH_ItemRepFrame:GetText())
            elseif faction == 2 then
                GBL_ItemLargess[i].rep2 = tonumber(GBH_ItemRepFrame:GetText())
            elseif faction == 3 then
                GBL_ItemLargess[i].rep3 = tonumber(GBH_ItemRepFrame:GetText())
            elseif faction == 4 then
                GBL_ItemLargess[i].rep4 = tonumber(GBH_ItemRepFrame:GetText())
            elseif faction == 5 then
                GBL_ItemLargess[i].rep5 = tonumber(GBH_ItemRepFrame:GetText())
            end
            GBL_ItemLargess[i].largess = MoneyInputFrame_GetCopper(GBH_ItemLargessMoneyFrame)             
            GBL_ItemLargess[i].timestamp = time()
            ChatThrottleLib:SendAddonMessage("NORMAL","GBL_IL_UPDATE", GBL_ItemLargessToString(i),"GUILD")
            return 
        end
    end
    
    --new item 
    local rep1,rep2,rep3,rep4,rep5
    if faction == 1 then
        rep1 = tonumber(GBH_ItemRepFrame:GetText())
    elseif faction == 2 then
        rep2 = tonumber(GBH_ItemRepFrame:GetText())
    elseif faction == 3 then
        rep3 = tonumber(GBH_ItemRepFrame:GetText())
    elseif faction == 4 then
        rep4 = tonumber(GBH_ItemRepFrame:GetText())
    elseif faction == 5 then
        rep5 = tonumber(GBH_ItemRepFrame:GetText())
    end
    
    rep1 = rep1 or 0
    rep2 = rep2 or 0
    rep3 = rep3 or 0
    rep4 = rep4 or 0
    rep5 = rep5 or 0
    
    table.insert(GBL_ItemLargess, {timestamp=time(),item=item,largess=value,rep1=rep1,rep2=rep2,rep3=rep3,rep4=rep4,rep5=rep5}) 
    ChatThrottleLib:SendAddonMessage("NORMAL","GBL_IL_UPDATE", GBL_ItemLargessToString(#GBL_ItemLargess),"GUILD")
end

function GBH_DelItemFromLargessList()
    if GBL_ItemLargess == nil then
        GBL_ItemLargess = {}
    end
    table.remove(GBL_ItemLargess, GBH_ItemLargessCurrentEntry)
end

--drag and drop item largess
function GBH_ItemLargessIconOnClick()
    local auctionPrice, vendorPrice, gbhPrice
    local typ, data, subType = GetCursorInfo()
    if typ == "item" then
        local tex = GetItemIcon(data)
        GBH_ItemLargessIconButtonIcon:SetTexture(tex)        
        ClearCursor()
        local name, link, quality,  _, _, _, _, _, _, _, vendorPrice  = GetItemInfo(data)
        GBH_CurrentItemLargessIconItem = link
        --GBH_CurrentItemLargessIconItem = data
        GBH_ItemLargessFrame_AddItemName_String:SetText(name)
        local r,g,b = GetItemQualityColor(quality)
        GBH_ItemLargessFrame_AddItemName_String:SetTextColor(r,g,b,1)  
        
        --check auction price
        local _,_,_,gotauc,_,_,_ = GetAddOnInfo("Auctionator")
        if gotauc then
            auctionPrice = GetAuctionBuyout(link)
        end
        if auctionPrice == nil then
            auctionPrice = 0
        end
        
        --check vendor price                                        
        if vendorPrice == nil then
            vendorPrice = 0
        end
        
        --use higher price
        if auctionPrice > vendorPrice then
            gbhPrice = auctionPrice
        else
            gbhPrice =  vendorPrice       
        end
        
        --change money to new item value
        MoneyInputFrame_SetCopper(GBH_ItemLargessMoneyFrame, gbhPrice)
    end
end

--auto add guild bank items to item list
function GBH_ImportGuildBankItems(discount)
    local tab,slot,gbhPrice,link,name
    if discount == nil then
        discount = 0
    end
    for tab = 1, GetNumGuildBankTabs() do
        for slot = 1, GBL_GBNUMSLOTS do
            --get item link from GB slot
            item = nil
            item = GetGuildBankItemLink(tab, slot)
            if item ~=nil then
                name, link = GetItemInfo(item)
                --check auction price
                local _,_,_,gotauc,_,_,_ = GetAddOnInfo("Auctionator")
                if gotauc then
                    auctionPrice = GetAuctionBuyout(link)
                end
                if auctionPrice == nil then
                    auctionPrice = 0
                end
                
                --check vendor price                                        
                if vendorPrice == nil then
                    vendorPrice = 0
                end
                
                --use higher price
                if auctionPrice > vendorPrice then
                    gbhPrice = auctionPrice
                else
                    gbhPrice =  vendorPrice       
                end
                GBH_AddItemToLargessList(link, floor(gbhPrice-gbhPrice*discount))
            end
        end
    end
end

function GBH_EnterItemLargessListButton(self)
    --GBH_ItemLargessEntryOnClick(self:GetParent())
    GameTooltip_SetDefaultAnchor(GameTooltip,UIParent)
    GameTooltip:ClearLines()
    --if GBH_CurrentItemLargessIconItem ~= nil then
        -- change this --------------------v
        GameTooltip:SetHyperlink(self:GetParent().data)
        GameTooltip:Show()
    --end
end
 
function GBH_LeaveItemLargessListButton()
    GameTooltip:Hide()
end

function GBH_CreateItemLargessView()
   local i,frame,textString,moneyFrame   
   
   --GBH_UIFrame:SetScript("OnShow",GBH_UIShow)   
   GBH_ItemLargessScrollFrame:EnableMouse()
   GBH_ItemLargessScrollFrame:EnableMouseWheel(1)   
   GBH_ItemLargessScrollFrame:SetScript("OnShow",GBH_ItemLargessFrameUpdate) 
   GBH_ItemLargessFrame:SetScript("OnUpdate",function() GBH_ItemLargessListUpdate() end)
   GBH_ItemLargessScrollFrame:Show()     
   
   --List Entry Frames (faux scroll frames)
   for i = 0,GBH_NUM_ITEMLARGESS_ENTRIES-1 do       
      frame = CreateFrame("Button","GBH_ItemLargessEntry"..i,GBH_ItemLargessScrollFrame,"GBH_ItemLargessEntryTemplate")
      frame:SetPoint("TOPLEFT",0,-i*28)  
      --_G["GBH_ItemLargessEntry"..i.."_ItemLargess"]:SetScale(.9)
      frame:Show() 
   end 
   --GBH_ListEntryNormalTexture = frame:GetNormalTexture()
   GBH_ItemLargessScrollFrame:SetPoint("TOPLEFT",15,-100) 
   GBH_ItemLargessCurrentEntry = 0
   --MoneyFrame_Update(GBH_RosterMoneyFrame, 0); 
   GBH_ItemLargessListUpdate()
   
end  

function GBH_ItemLargessListUpdate()
    local i,dataOffset,offset,n,m,r,g,b
    local moneyFrame,textString,entryFrame,iconButton,iconTexture
    
    n = #GBL_ItemLargess    
    FauxScrollFrame_Update(GBH_ItemLargessScrollFrame,n,GBH_NUM_ITEMLARGESS_ENTRIES,28,nil,nil,nil,nil,nil,nil,true);
    offset = FauxScrollFrame_GetOffset(GBH_ItemLargessScrollFrame);
       
       for i = 0,GBH_NUM_ITEMLARGESS_ENTRIES-1 do
          dataOffset = offset + i + 1 
          iconButton = _G["GBH_ItemLargessEntry"..i.."_Icon"]
          iconTexture = _G["GBH_ItemLargessEntry"..i.."_Icon_Texture"]
          textString = _G["GBH_ItemLargessEntry"..i.."_ItemName"]
          moneyFrame = _G["GBH_ItemLargessEntry"..i.."_ItemLargess"]          
          entryFrame = _G["GBH_ItemLargessEntry"..i]     
          if dataOffset <= n then 
            -- set icon texture
            local tex = GetItemIcon(GBL_ItemLargess[dataOffset].item)
            iconTexture:SetTexture(tex)            
            --set item money
            MoneyFrame_Update(moneyFrame, GBL_ItemLargess[dataOffset].largess);             
            --set item name
            local name, link, quality = GetItemInfo(GBL_ItemLargess[dataOffset].item)
            textString:SetText(name)             
            --GBH_CurrentItemLargessIconItem = link
            textString:SetText(name)
            if quality then
                r,g,b = GetItemQualityColor(quality)
                textString:SetTextColor(r,g,b,1)
            end
            
            --set current index
            entryFrame.index = dataOffset  
            entryFrame.data = GBL_ItemLargess[dataOffset].item
            if GBH_ItemLargessCurrentEntry == dataOffset then
                --set selected texture            
                entryFrame:LockHighlight()
            else
                --reset normal texture
                entryFrame:UnlockHighlight()
            end  
            
             entryFrame:Show()         
          else
             entryFrame:Hide()                
          end        
       end    
end

function GBH_ItemLargessEntryOnClick(self)
    GBH_ItemLargessCurrentEntry = self.index
    --GBL_LargessMessage(self.index)   
    local tex = GetItemIcon(self.data)
    GBH_ItemLargessIconButtonIcon:SetTexture(tex) 
    local name, link, quality = GetItemInfo(self.data)
    GBH_CurrentItemLargessIconItem = link
    GBH_ItemLargessFrame_AddItemName_String:SetText(name)
    local r,g,b = GetItemQualityColor(quality)
    GBH_ItemLargessFrame_AddItemName_String:SetTextColor(r,g,b,1) 
    MoneyInputFrame_SetCopper(GBH_ItemLargessMoneyFrame, GBL_ItemLargess[self.index].largess)
    
    --populate rep edit box
    local faction = UIDropDownMenu_GetSelectedID(GBH_ItemFactionSelectMenu) or 1
    local rep
    if faction == 1 then
        rep = GBL_ItemLargess[self.index].rep1
    elseif faction == 2 then
        rep = GBL_ItemLargess[self.index].rep2
    elseif faction == 3 then
        rep = GBL_ItemLargess[self.index].rep3
    elseif faction == 4 then
        rep = GBL_ItemLargess[self.index].rep4
    elseif faction == 5 then
        rep = GBL_ItemLargess[self.index].rep5
    end
    GBH_ItemRepFrame:SetText(rep or 0)
end

function GBH_ItemLargessListOnClick()
    --not sure what to with this yet
end

function GBH_SortByItem(a,b)
    local aname = GetItemInfo(a.item)
    local bname = GetItemInfo(b.item)
	
    if GBH_ITEM_SORT then  
        return aname > bname
    else      
        return aname < bname
    end
end

function GBH_SortByItemLargess(a,b)
    if GBH_ITEM_LARGESS_SORT then
        return tonumber(a.largess) > tonumber(b.largess)
    else
       return tonumber(a.largess) < tonumber(b.largess)
    end
end

function GBH_SortByGuildieLargess(a,b)
    if GBH_SORT_GUILDIE_LARGESS then
        --return GBL_AuditData[a.name].largess > GBL_AuditData[b.name].largess
        return a.largess > b.largess
    else
       --return GBL_AuditData[a.name].largess < GBL_AuditData[b.name].largess
       return a.largess < b.largess
    end
end

function GBH_SortByGuildie(a,b)
    if GBH_SORT_GUILDIE then
        return a.name > b.name
    else
        return a.name < b.name
    end
end

function GBH_ItemFactionSelectDropDownOnLoad(self)
    --GBL_LargessMessage("Faction OnLoad")
    UIDropDownMenu_Initialize(self, GBH_ItemFactionSelectMenuInitialize)
end

function GBH_ItemFactionSelectMenuInitialize()
    --GBL_LargessMessage("Faction Init") 
    GBH_ItemFactionSelectMenuButton:SetScript("OnClick", GBH_ItemFactionSelectMenuOnClick)
    
    --Faction 1    
    local info = {}
    info.text = GBL_GuildFactions[1].title       
    info.func = GBH_ItemFactionMenuItemClick
    if UIDropDownMenu_GetSelectedValue(GBH_ItemFactionSelectMenu) == GBL_GuildFactions[1].title then
        info.checked = true
        --GBH_ItemLargessMoneyFrame:Hide()
    else
        info.checked = nil        
    end
    UIDropDownMenu_AddButton(info)
    
    --Faction 2
    info = {}
    info.text = GBL_GuildFactions[2].title
    info.func = GBH_ItemFactionMenuItemClick
    if UIDropDownMenu_GetSelectedValue(GBH_ItemFactionSelectMenu) == GBL_GuildFactions[2].title then
        info.checked = true
    else
        info.checked = nil
    end
    UIDropDownMenu_AddButton(info)
    
    --Faction 3
    info = {}
    info.text = GBL_GuildFactions[3].title
    info.func = GBH_ItemFactionMenuItemClick
    if UIDropDownMenu_GetSelectedValue(GBH_ItemFactionSelectMenu) == GBL_GuildFactions[3].title then
        info.checked = true
    else
        info.checked = nil
    end
    UIDropDownMenu_AddButton(info)
    
    --Faction 4
    info = {}
    info.text = GBL_GuildFactions[4].title
    info.func = GBH_ItemFactionMenuItemClick
    if UIDropDownMenu_GetSelectedValue(GBH_ItemFactionSelectMenu) == GBL_GuildFactions[4].title then
        info.checked = true
    else
        info.checked = nil
    end
    UIDropDownMenu_AddButton(info)
    
    --Faction 5
    info = {}
    info.text = GBL_GuildFactions[5].title
    info.func = GBH_ItemFactionMenuItemClick
    if UIDropDownMenu_GetSelectedValue(GBH_ItemFactionSelectMenu) == GBL_GuildFactions[5].title then
        info.checked = true
    else
        info.checked = nil
    end
    UIDropDownMenu_AddButton(info)  
    
    --default value
    if UIDropDownMenu_GetSelectedValue(GBH_ItemFactionSelectMenu) == nil then
        UIDropDownMenu_SetSelectedValue(GBH_ItemFactionSelectMenu, GBL_GuildFactions[1].title)
    end
end

function GBH_ItemFactionSelectMenuOnClick(self)
    --GBL_LargessMessage("Faction Click...")
    ToggleDropDownMenu(1, nil, GBH_ItemFactionDropDownFrame, self:GetName(), -100, 0)
end

function GBH_ItemFactionMenuItemClick(self)    
    GBL_LargessMessage(self.value)
    UIDropDownMenu_SetSelectedValue(GBH_ItemFactionSelectMenu, self.value)  
    UIDropDownMenu_SetSelectedValue(GBH_ItemFactionSelectMenu, self.value) 
    GBH_FactionRepMenuInitialize()
    
    --populate rep edit box
    if GBH_ItemLargessCurrentEntry == nil then
        return
    end
    local faction = UIDropDownMenu_GetSelectedID(GBH_ItemFactionSelectMenu) or 1
    local rep
    if faction == 1 then
        rep = GBL_ItemLargess[GBH_ItemLargessCurrentEntry].rep1
    elseif faction == 2 then
        rep = GBL_ItemLargess[GBH_ItemLargessCurrentEntry].rep2
    elseif faction == 3 then
        rep = GBL_ItemLargess[GBH_ItemLargessCurrentEntry].rep3
    elseif faction == 4 then
        rep = GBL_ItemLargess[GBH_ItemLargessCurrentEntry].rep4
    elseif faction == 5 then
        rep = GBL_ItemLargess[GBH_ItemLargessCurrentEntry].rep5
    end
    GBH_ItemRepFrame:SetText(rep or 0)
    
    --GBH_FactionFrameUpdate()
end

