function GBH_HL_DoSync(sender)   
    local i,n
    if GBH_HitList == nil then  
        GBH_HitList={};
    end        
    n = #GBH_HitList        
    for  i = 1, n do        
      msg = GBH_BountyToString(i)
      
      gbh_debug("Send: "..msg)   
      
      --ChatThrottleLib:SendAddonMessage("NORMAL","GBH_HL_UPDATE",msg,"WHISPER",sender);
      ChatThrottleLib:SendAddonMessage("BULK","GBH_HL_UPDATE",msg,"GUILD");
    end
end    

function GBH_HL_DoUpdate(msg,sender)  
    local id,name,issuer,amount,state,claimer,timestamp,f,i,audit,faction,realm,zone,xcoord,ycoord,intelage,class,race,level
    local f, i
    id,timestamp,name,issuer,amount,claimer,state,audit,faction,realm,zone,xcoord,ycoord,intelage,class,race,level = string.split(",",msg) 
    
    --must have valid name and amount
    if name == nil or amount == nil then 
        gbh_debug("GBH_HL_DoUpdate: Error: name or amount is nil.")
        return
    end     
    
    --enforce officer lock (don't accept updates on locked bounties from nonofficers unless they are the issuer)
    if ((state == "GBH_OPEN_SL" or state == "GBH_OPEN_L" or state == "GBH_CLAIMED_L") and select(3,GetGuildInfo(sender)) > GBH_MinOfficerRank) and (sender ~= issuer) then            
        return
    end
    
    if intelage == nil then 
        intelage = 0
    end   
    
    f,i = InHitList(id)
    gbh_debug("Is InHitList["..i.."]:"..tostring(f))
    
    if f ~= nil or f == false then
    
        gbh_debug("New: "..msg)
        
        table.insert(GBH_HitList,{id=id,name=name,amount=amount,issuer=issuer,timestamp=timestamp,state=state,claimer=claimer,audit=audit,faction=faction,realm=realm,zone=zone,xcoord=xcoord,ycoord=ycoord,intelage=tonumber(intelage),class=class,race=race,level=level});  
        GBH_HitListUpdate()        
               
    elseif (tonumber(timestamp) > tonumber(GBH_HitList[i].timestamp)) then       
        
        gbh_debug("Update: "..msg)
        
        GBH_HitList[i].id = id
        GBH_HitList[i].name = name
        GBH_HitList[i].amount = amount
        GBH_HitList[i].issuer = issuer
        GBH_HitList[i].timestamp = timestamp
        GBH_HitList[i].state = state
        GBH_HitList[i].claimer = claimer   
        GBH_HitList[i].audit = audit
        GBH_HitList[i].faction = faction
        GBH_HitList[i].realm = realm
        if GBH_HitList[i].intelage == nil then
           GBH_HitList[i].intelage = 0
        end      
        if (tonumber(intelage) > tonumber(GBH_HitList[i].intelage)) then
            GBH_HitList[i].zone = zone
            GBH_HitList[i].xcoord = xcoord
            GBH_HitList[i].ycoord = ycoord
            GBH_HitList[i].intelage = tonumber(intelage)
            GBH_HitList[i].class = class
            GBH_HitList[i].race = race
            GBH_HitList[i].level = level
            GBH_HitListUpdate()
        end
    end    
end

function GBH_BountyToString(i)
    local name = GBH_HitList[i].name
    local amount = GBH_HitList[i].amount   
    local id = GBH_HitList[i].id      
    local issuer = GBH_HitList[i].issuer
    local timestamp = GBH_HitList[i].timestamp
    local state = GBH_HitList[i].state
    local claimer = GBH_HitList[i].claimer  
    local audit = GBH_HitList[i].audit
    local faction = GBH_HitList[i].faction
    local realm = GBH_HitList[i].realm
    local zone = GBH_HitList[i].zone
    local xcoord = GBH_HitList[i].xcoord
    local ycoord = GBH_HitList[i].ycoord
    local intelage = GBH_HitList[i].intelage
    local class = GBH_HitList[i].class
    local race = GBH_HitList[i].race
    local level = GBH_HitList[i].level
   
    if audit == nil then 
        audit  = 0
    end   
    if faction == nil then
        faction = "UNKNOWN"
    end   
    if GBH_HitList[i].realm == nil then
        realm = ""
    end   
    if GBH_HitList[i].zone == nil then
       zone = ""
    end   
    if GBH_HitList[i].xcoord == nil then
       xcoord = ""
    end   
    if GBH_HitList[i].ycoord == nil then
       ycoord = ""
    end   
    if GBH_HitList[i].class == nil then
       class = ""
    end  
    if GBH_HitList[i].race == nil then
       race = ""
    end
    if GBH_HitList[i].level == nil then
       level = ""
    end   
    if GBH_HitList[i].intelage == nil then
       intelage = 0
    end   
    local msg = id..","..timestamp..","..name..","..issuer..","..amount..","..claimer..","..state..","..audit..","..faction..","..realm..","..zone..","..xcoord..","..ycoord..","..intelage..","..class..","..race..","..level;
  
    return msg
end

--Item Largess Table Sync
function GBL_IL_DoSync(sender)   
    local i,n
    if GBL_ItemLargess == nil then  
        GBL_ItemLargess={};
    end        
    n = #GBL_ItemLargess        
    for  i = 1, n do        
      msg = GBL_ItemLargessToString(i)
      
      gbh_debug("Send: "..msg)      
      
      --ChatThrottleLib:SendAddonMessage("NORMAL","GBH_HL_UPDATE",msg,"WHISPER",sender);
      ChatThrottleLib:SendAddonMessage("BULK","GBL_IL_UPDATE",msg,"GUILD");
    end
end    

function GBL_IL_DoUpdate(msg)  
    local timestamp, item, largess, rep1, rep2, rep3, rep4, rep5, i, s, e
  
    timestamp, largess, item, rep1, rep2, rep3, rep4, rep5 = string.split(",", msg)      
    i = GBL_InItemLargess(item)
  
    if i == nil then
        table.insert(GBL_ItemLargess,{timestamp=timestamp, item=item, largess=largess, rep1=rep1, rep2=rep2, rep3=rep3, rep4=rep4, rep5=rep5});  
        GBH_ItemLargessListUpdate()
        
        gbh_debug("New: "..msg) 
        
    elseif (tonumber(timestamp) > tonumber(GBL_ItemLargess[i].timestamp)) then
        GBL_ItemLargess[i].timestamp = timestamp
        GBL_ItemLargess[i].item = item
        GBL_ItemLargess[i].largess = largess 
        GBL_ItemLargess[i].rep1 = rep1
        GBL_ItemLargess[i].rep2 = rep2
        GBL_ItemLargess[i].rep2 = rep3
        GBL_ItemLargess[i].rep2 = rep4
        GBL_ItemLargess[i].rep2 = rep5
        
        gbh_debug("Update: "..msg)
        
    end    
end

function GBL_InItemLargess(item)
    local i   
    
    for i = 1, #GBL_ItemLargess do
        if item == GBL_ItemLargess[i].item then
            --return the index of item
            return i
        end
    end
    
    return nil
end    

function GBL_ItemLargessToString(i)
    local timestamp = GBL_ItemLargess[i].timestamp
    local item = GBL_ItemLargess[i].item
    local largess = GBL_ItemLargess[i].largess
    local rep1 = GBL_ItemLargess[i].rep1 or 0
    local rep2 = GBL_ItemLargess[i].rep2 or 0
    local rep3 = GBL_ItemLargess[i].rep3 or 0
    local rep4 = GBL_ItemLargess[i].rep4 or 0
    local rep5 = GBL_ItemLargess[i].rep5 or 0
    
    return timestamp..","..largess..","..item..","..rep1..","..rep2..","..rep3..","..rep4..","..rep5
end

function GBH_GF_DoUpdateDescription(msg)  
    local timestamp, faction, desc
  
    timestamp, faction, desc = string.split(":", msg)  
    timestamp = tonumber(timestamp)
    faction = tonumber(faction)
    if timestamp >= GBL_GuildFactions[faction].timestamp then
        GBL_GuildFactions[faction].description = desc
        GBL_GuildFactions[faction].timestamp = timestamp
        
        gbh_debug("Update: "..msg)
        
    end    
end

--update faction title, gold to rep, bounty to rep and repairs to rep
function GBH_GF_DoUpdateTitle(msg)
    local timestamp, faction, title, goldtorep, bountytorep, repairstorep
    
    timestamp, faction, title, goldtorep, bountytorep, repairstorep = string.split(",", msg)
    timestamp = tonumber(timestamp)
    faction = tonumber(faction)
    if timestamp >= GBL_GuildFactions[faction].timestamp then
        GBL_GuildFactions[faction].title = title
        GBL_GuildFactions[faction].timestamp = timestamp
        GBL_GuildFactions[faction].goldtorep = tonumber(goldtorep)
        GBL_GuildFactions[faction].bountytorep = tonumber(bountytorep)
        GBL_GuildFactions[faction].repairstorep = tonumber(repairstorep)        
        
        gbh_debug("Update: "..msg)
        
    end   
end

function GBH_GF_DoUpdateDiscounts(msg)
    local timestamp, faction, discount
    
    timestamp, faction, discount = string.split(",", msg)
    timestamp = tonumber(timestamp)
    faction = tonumber(faction)
    local d11,d12,d13,d14,d21,d22,d23,d24,d31,d32,d33,d34,d41,d42,d43,d44,d51,d52,d53,d54,d61,d62,d63,d64,d71,d72,d73,d74,d81,d82,d83,d84 = string.split(":", discount)
    if timestamp >= GBL_GuildFactions[faction].timestamp then
        GBL_GuildFactions[faction].discount[1][1] = tonumber(d11)
        GBL_GuildFactions[faction].discount[1][2] = tonumber(d12)
        GBL_GuildFactions[faction].discount[1][3] = tonumber(d13)
        GBL_GuildFactions[faction].discount[1][4] = tonumber(d14)
        GBL_GuildFactions[faction].discount[2][1] = tonumber(d21)
        GBL_GuildFactions[faction].discount[2][2] = tonumber(d22)
        GBL_GuildFactions[faction].discount[2][3] = tonumber(d23)
        GBL_GuildFactions[faction].discount[2][4] = tonumber(d24)
        GBL_GuildFactions[faction].discount[3][1] = tonumber(d31)
        GBL_GuildFactions[faction].discount[3][2] = tonumber(d32)
        GBL_GuildFactions[faction].discount[3][3] = tonumber(d33)
        GBL_GuildFactions[faction].discount[3][4] = tonumber(d34)
        GBL_GuildFactions[faction].discount[4][1] = tonumber(d41)
        GBL_GuildFactions[faction].discount[4][2] = tonumber(d42)
        GBL_GuildFactions[faction].discount[4][3] = tonumber(d43)
        GBL_GuildFactions[faction].discount[4][4] = tonumber(d44)
        GBL_GuildFactions[faction].discount[5][1] = tonumber(d51)
        GBL_GuildFactions[faction].discount[5][2] = tonumber(d52)
        GBL_GuildFactions[faction].discount[5][3] = tonumber(d53)
        GBL_GuildFactions[faction].discount[5][4] = tonumber(d54)
        GBL_GuildFactions[faction].discount[6][1] = tonumber(d61)
        GBL_GuildFactions[faction].discount[6][2] = tonumber(d62)
        GBL_GuildFactions[faction].discount[6][3] = tonumber(d63)
        GBL_GuildFactions[faction].discount[6][4] = tonumber(d64)
        GBL_GuildFactions[faction].discount[7][1] = tonumber(d71)
        GBL_GuildFactions[faction].discount[7][2] = tonumber(d72)
        GBL_GuildFactions[faction].discount[7][3] = tonumber(d73)
        GBL_GuildFactions[faction].discount[7][4] = tonumber(d74)
        GBL_GuildFactions[faction].discount[8][1] = tonumber(d81)
        GBL_GuildFactions[faction].discount[8][2] = tonumber(d82)
        GBL_GuildFactions[faction].discount[8][3] = tonumber(d83)
        GBL_GuildFactions[faction].discount[8][4] = tonumber(d84)  
        
        gbh_debug("Update: "..msg)
        
    end   
end

--send all guild faction data to the guild
function GBH_GF_DoSync()   
    local timestamp, faction, title, goldtorep, bountytorep, repairstorep, description, msg
    local d11,d12,d13,d14,d21,d22,d23,d24,d31,d32,d33,d34,d41,d42,d43,d44,d51,d52,d53,d54,d61,d62,d63,d64,d71,d72,d73,d74,d81,d82,d83,d84
           
    for  faction = 1, GBL_MAX_NUM_GUILD_FACTIONS do        
        --faction title message       
        timestamp = tostring(GBL_GuildFactions[faction].timestamp)
        title = GBL_GuildFactions[faction].title
        description = GBL_GuildFactions[faction].description
        goldtorep = tostring(GBL_GuildFactions[faction].goldtorep)
        bountytorep = tostring(GBL_GuildFactions[faction].bountytorep)
        repairstorep = tostring(GBL_GuildFactions[faction].repairstorep)
        
        msg = timestamp..","..tostring(faction)..","..title..","..goldtorep..","..bountytorep..","..repairstorep      
        gbh_debug("Send: "..msg)                 
        ChatThrottleLib:SendAddonMessage("BULK","GBH_GF_UPDATE_1",msg,"GUILD");
        
        --faction description message
        msg = timestamp..":"..tostring(faction)..":"..description        
        gbh_debug("Send: "..msg)       
        ChatThrottleLib:SendAddonMessage("BULK","GBH_GF_UPDATE_2",msg,"GUILD");
        
        --faction discount message
        d11 = GBL_GuildFactions[faction].discount[1][1]
        d12 = GBL_GuildFactions[faction].discount[1][2]
        d13 = GBL_GuildFactions[faction].discount[1][3]
        d14 = GBL_GuildFactions[faction].discount[1][4]
        d21 = GBL_GuildFactions[faction].discount[2][1]
        d22 = GBL_GuildFactions[faction].discount[2][2]
        d23 = GBL_GuildFactions[faction].discount[2][3]
        d24 = GBL_GuildFactions[faction].discount[2][4]
        d31 = GBL_GuildFactions[faction].discount[3][1]
        d32 = GBL_GuildFactions[faction].discount[3][2]
        d33 = GBL_GuildFactions[faction].discount[3][3]
        d34 = GBL_GuildFactions[faction].discount[3][4]
        d41 = GBL_GuildFactions[faction].discount[4][1]
        d42 = GBL_GuildFactions[faction].discount[4][2]
        d43 = GBL_GuildFactions[faction].discount[4][3]
        d44 = GBL_GuildFactions[faction].discount[4][4]
        d51 = GBL_GuildFactions[faction].discount[5][1]
        d52 = GBL_GuildFactions[faction].discount[5][2]
        d53 = GBL_GuildFactions[faction].discount[5][3]
        d54 = GBL_GuildFactions[faction].discount[5][4]
        d61 = GBL_GuildFactions[faction].discount[6][1]
        d62 = GBL_GuildFactions[faction].discount[6][2]
        d63 = GBL_GuildFactions[faction].discount[6][3]
        d64 = GBL_GuildFactions[faction].discount[6][4]
        d71 = GBL_GuildFactions[faction].discount[7][1]
        d72 = GBL_GuildFactions[faction].discount[7][2]
        d73 = GBL_GuildFactions[faction].discount[7][3]
        d74 = GBL_GuildFactions[faction].discount[7][4]
        d81 = GBL_GuildFactions[faction].discount[8][1]
        d82 = GBL_GuildFactions[faction].discount[8][2]
        d83 = GBL_GuildFactions[faction].discount[8][3]
        d84 = GBL_GuildFactions[faction].discount[8][4]  
        msg = timestamp..","..tostring(faction)..","..d11..":"..d12..":"..d13..":"..d14..":"..d21..":"..d22..":"..d23..":"..d24..":"..d31..":"..d32..":"..d33..":"..d34..":"..d41..":"..d42..":"..d43..":"..d44..":"..d51..":"..d52..":"..d53..":"..d54..":"..d61..":"..d62..":"..d63..":"..d64..":"..d71..":"..d72..":"..d73..":"..d74..":"..d81..":"..d82..":"..d83..":"..d84
        gbh_debug("Send: "..msg)       
        ChatThrottleLib:SendAddonMessage("BULK","GBH_GF_UPDATE_3",msg,"GUILD");
        
    end
end    