function GBL_AddLargess(amount)     
   amount = tonumber(amount)
   GBL_Largess = GBL_Largess + amount;
   local msg = "Your guild Largess has increased by "..GBL_CopperToGold(amount);
   GBL_LargessMessage(msg, "green")
   if GBL_Largess >= 0 then
      GBL_LargessMessage("Current Largess: "..GBL_CopperToGold(GBL_Largess),"green");
   else
      GBL_LargessMessage("Current Largess: "..GBL_CopperToGold(GBL_Largess),"red");
   end
   if GBH_LargessAmountFrame then
      MoneyFrame_Update(GBH_LargessAmountFrame, GBL_Largess);
   end
end

function GBL_SubLargess(amount) 
   amount = tonumber(amount) 
   GBL_Largess = GBL_Largess - amount;
   local msg = "Your guild Largess has decreased by "..GBL_CopperToGold(amount);
   GBL_LargessMessage(msg,"red");
   msg = "Current Largess: "..GBL_CopperToGold(GBL_Largess)
   if GBL_Largess >= 0 then
        GBL_LargessMessage(msg,"green")
   else
        GBL_LargessMessage(msg,"red")
   end
   if GBH_LargessAmountFrame then
      MoneyFrame_Update(GBH_LargessAmountFrame, GBL_Largess);
   end
end

function GBL_LargessMessage(msg,color)   
   if (color == nil) or (color == "GREEN") or (color == "green") then 
      --default color is green
      DEFAULT_CHAT_FRAME:AddMessage(msg, 0, 1, 0);
   elseif (color == "RED") or (color == "red") then
      --here's red
      DEFAULT_CHAT_FRAME:AddMessage(msg, 1, 0, 0);
   elseif (color == "sys") then
      --yellow?
      DEFAULT_CHAT_FRAME:AddMessage(msg, 1, 1, 0);
   elseif (color == "rep") then
      DEFAULT_CHAT_FRAME:AddMessage(msg, GetMessageTypeColor("CHAT_MSG_COMBAT_FACTION_CHANGE"));
   end   
end

function GBL_CopperToGold(copper)
   local gp,sp,cp,gsp;    
   gp = floor(tonumber(copper)/10000);
   sp = abs(floor(mod(tonumber(copper),10000)/100));   
   cp = abs(mod(mod(tonumber(copper),10000),100));    
   gsp = tostring(gp).."g "..tostring(sp).."s "..tostring(cp).."c";
   return gsp;
end

function GBL_GetGBCut()  
    if GBL_GuildBankText == nil then
        QueryGuildBankText(1)
        return 0
    end
    if GBL_GuildBankText[1] == nil or GBL_GuildBankText[1] == "" then
        return tonumber(0)
    end
    local s,e,cut,a2,a3,a4,a5 = string.find(GBL_GuildBankText[1],"<GBL:C0><(.+)><(.+)><(.+)><(.+)><(.+)><(.+)></C>")
    if cut then
       return cut   
    else
       return tonumber(0)
    end
end

function GBL_SetGBCut(cut)
   if not CanEditGuildTabInfo(1) then
      GBL_LargessMessage("You do not have permission to edit guild bank tab:1 info.")
      return
   end
   
   local ginfo = GBL_GuildBankText[1]
   if ginfo == nil then
      ginfo = ""
   end
   local gbc,n = string.gsub(ginfo,"<GBL:C0><?%d*>","<GBL:C0><"..cut..">")  
   if n == 1 then       
      SetGuildBankText(1, gbc)
      GBL_GuildBankText[1] = gbc
   else  
      --do this only if bank text has other stuff in it
      SetGuildBankText(1, ginfo.."<GBL:C0><"..cut..">")
      GBL_GuildBankText[1] = ginfo.."<GBL:C0><"..cut..">"
   end
   QueryGuildBankText(1)
end

function GBL_SetLargess(name, amount)
   if not CanEditOfficerNote() then 
      GBL_LargessMessage("You do not have permission to edit officer notes.")
      return
   end
   
   local i,gnum
   
   GBL_AuditInit()
   GBL_AuditLoad()  
   
   if name == "all" then
      gnum = #GBL_GuildMates
      for i = 1,gnum do
         GBL_AuditData[GBL_GuildMates[i].name].largess = tonumber(amount)
      end
   else
      GBL_AuditData[name].largess = tonumber(amount)
   end
   
   GBL_AuditSave()
end

function GBL_ModLargess(name, amount)
   if not CanEditOfficerNote() then 
      GBL_LargessMessage("You do not have permission to edit officer notes.")
      return
   end
   
   local i,gnum
   
   GBL_AuditInit()
   GBL_AuditLoad()  
   
   if name == "all" then
      gnum = #GBL_GuildMates
      for i = 1,gnum do         
         GBL_AuditData[GBL_GuildMates[i].name].largess = GBL_AuditData[GBL_GuildMates[i].name].largess + tonumber(amount)         
      end
   else
      GBL_AuditData[name].largess = GBL_AuditData[name].largess + tonumber(amount)      
   end
   
   GBL_AuditSave()
end   

function GBL_GuildLargessReport()
   if not CanViewOfficerNote() then
      GBL_LargessMessage("You do not have permission to view officer notes.")
      return
   end  
   local i,name,largess
   GBL_AuditInit()
   GBL_AuditLoad()
   GBL_LargessMessage("-------------------------------")
   GBL_LargessMessage("Guild Largess Report")
   GBL_LargessMessage("-------------------------------")
   
   for i = 1,#GBL_GuildMates do
      name = GBL_GuildMates[i].name
      largess = GBL_AuditData[name].largess
      if largess < 0 then
         GBL_LargessMessage(name..": "..GBL_CopperToGold(largess),"red")
      else
         GBL_LargessMessage(name..": "..GBL_CopperToGold(largess),"green")
      end
   end
end

function GBL_AuditPrep()
    local i
   if GBL_GetAdminLevel() < GBL_SUPER_ADMIN then
      GBL_LargessMessage("You do not have permission to perform audits.")
      return
   end   
   GBL_LargessMessage("Guild Bank audit pending...")
   if not GBL_BANKLOG_UPDATED then
      GBL_LargessMessage("Guild Bank Money Log update required.")
   end
   if not GBL_ROSTER_UPDATED then
      GBL_LargessMessage("Guild Roster update required.")
   end 
   GBL_DO_AUDIT = true
   for i = 1,GetNumGuildBankTabs() do
        QueryGuildBankText(i)
    end
   QueryGuildBankLog(MAX_GUILDBANK_TABS+1)   
   GuildRoster()
end

function GBL_InitGBItemList()
    local i,tab
    tab = GetCurrentGuildBankTab()
    GBL_TabItemList = {}
    for i = 1,GBL_GBNUMSLOTS do
        GBL_TabItemList[i] = {}
        GBL_TabItemList[i].link = GetGuildBankItemLink(tab,i)
        GBL_TabItemList[i].count = select(2,GetGuildBankItemInfo(tab,i))
    end
end

function GBL_HasGBTabChanged()
    local i,j,tab,link1,link2,cnt1,cnt2   
    tab = GetCurrentGuildBankTab()
    for i = 1,GBL_GBNUMSLOTS do
        if GBL_TabItemList[i].link ~= GetGuildBankItemLink(tab,i) then
            link1 = GBL_TabItemList[i].link
            link2 = GetGuildBankItemLink(tab,i)
            cnt1 = 0
            cnt2 = 0
            --count items from old list in case of move
            for j = 1,GBL_GBNUMSLOTS do
                if GBL_TabItemList[j].link == link1 then
                    cnt1 = cnt1 + GBL_TabItemList[j].count
                end
            end
            --count items in current tab
            for j = 1,GBL_GBNUMSLOTS do
                if GetGuildBankItemLink(tab,j) == link1 then                
                    cnt2 = cnt2 + select(2,GetGuildBankItemInfo(tab,j))
                end
            end
            if cnt1 ~= cnt2 then
                return true
            end
            --count items from old list in case of move
            for j = 1,GBL_GBNUMSLOTS do
                if GBL_TabItemList[j].link == link2 then
                    cnt1 = cnt1 + GBL_TabItemList[j].count
                end
            end
            --count items in current tab
            for j = 1,GBL_GBNUMSLOTS do
                if GetGuildBankItemLink(tab,j) == link2 then                
                    cnt2 = cnt2 + select(2,GetGuildBankItemInfo(tab,j))
                end
            end
            if cnt1 ~= cnt2 then
                return true
            end
        end
    end
    return false
end
